unit JS_CLUST;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_tio,js_koor,js_stm,js_mtr,js_gra;


Const
 MaxAnzClust=150;

Type
 SumRec_T =   record
               Anz: Word;
               Suv: Vector_2;
               Sum: Matrix_2;
              end;

 SumTab_T =   Array [1..MaxAnzClust] of SumRec_T;

 ClustRec_T = record
               Anz: Word;
               Cen: Vector_2;
               Eiw: Vector_2;
               Alf: Real;
              end;

 ClustTab_T = record
               Anz: Word;
               Dat: Array [1..MaxAnzClust] of ClustRec_T;
              end;

 RefTab_T   = record
               Anz: Word;
               Dat: Array [1..MaxAnzClust] of Vector_2;
              end;

Var
 ClustSchw:  Real;
 WndrgSchw:  Real;
 SlctSchw:   Real;
 NewClust:   Boolean;
 Wndrg:      Real;
 DsplTree:   Boolean;
 DsplElli:   Boolean;
 DsplLabel:  Boolean;
 SeedEigVek: Boolean;
 TreeColor:  Word;
 ElliColor:  Word;
 LabelColor: Word;
 StarColor:  Word;
 MaxSteps:   Word;


 ClustPfad,                         ClustSvDatei: PathStr;


procedure PfadeInitClu(PfadeMaske:MskPar_T);
procedure ColorInitClu(FarbeMaske:MskPar_T);

procedure ShowStchp;
procedure GoThruStchp(Var RefTab:RefTab_T; Var SumTab:SumTab_T; Var ClustTab:ClustTab_T; Var NewRef:RefTab_T);

procedure PlotElli(Alf:Real; Eiw:Vector_2; Cen:Vector_2);
procedure PlotCircle(Cen:Vector_2; Radius:Real);

procedure DsplEllipsen(ClustTab:ClustTab_T);
procedure DsplKreise(ClustTab:ClustTab_T);

procedure ClustInit(Var RefTab:RefTab_T);
procedure ClrSumTab(RefTab:RefTab_T; Var SumTab:SumTab_T);
procedure ClustStepAkku(v:Vector_2; RefTab:RefTab_T; Var SumTab:SumTab_T);
procedure ClustStepCmpl(RefTab:RefTab_T; SumTab:SumTab_T; Var ClustTab:ClustTab_T);
procedure ClustStepNewRef(ClustTab:ClustTab_T; RefTab:RefTab_T; Var NewRef:RefTab_T);

procedure MarkCen(ClustTab:ClustTab_T);

procedure WrClustTab(ClustSvDatei:PathStr; ClustTab:ClustTab_T);
procedure ShowStars(ClustTab:ClustTab_T);

procedure GenStMod(ClustTab:ClustTab_T; Var StMod:StMod_T);


Implementation

procedure PfadeInitClu(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=     PfadeMaske.erg[ 1];
 KoorRdDflt:=   PfadeMaske.erg[ 2];
 FarbePfad:=    PfadeMaske.erg[ 3];
 FarbeRdDflt:=  PfadeMaske.erg[ 4];
 StchpPfad:=    PfadeMaske.erg[ 5];
 StchpRdDflt:=  PfadeMaske.erg[ 6];
 ClustPfad:=    PfadeMaske.erg[ 7];
 StModPfad:=    PfadeMaske.erg[ 8];
 EditorPfad:=   PfadeMaske.erg[ 9];

 KoorRdDatei:=   KoorRdDflt;
 StchpRdDatei:=  StchpRdDflt;
 FarbeRdDatei:=  FarbeRdDflt;
 end;


procedure ColorInitClu(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 SmplColor:=         ColorFromStr(FarbeMaske.erg[4]);
 TreeColor:=         ColorFromStr(FarbeMaske.erg[5]);
 ElliColor:=         ColorFromStr(FarbeMaske.erg[6]);
 LabelColor:=        ColorFromStr(FarbeMaske.erg[7]);
 StarColor:=         ColorFromStr(FarbeMaske.erg[8]);
 end;

procedure ShowStchp;
 begin
 Reset(StchpRdFile);
 while not Eof(StchpRdFile) do
  begin
  ReadLn(StchpRdFile,SmplClass,SmplNr,v[1],v[2]);
  If (ClSlct=[]) or (SmplClass in ClSlct) then PlotV(v,SmplColor);
  end;
 end;


procedure GoThruStchp(Var RefTab:RefTab_T; Var SumTab:SumTab_T; Var ClustTab:ClustTab_T; Var NewRef:RefTab_T);
 Var strt:Boolean; Count:Word;
 begin
 strt:=True;
 Count:=0;
 ClustInit(RefTab);
 repeat
  ClrSumTab(RefTab,SumTab);

  Reset(StchpRdFile);
  while not Eof(StchpRdFile) do
   begin
   ReadLn(StchpRdFile,SmplClass,SmplNr,v[1],v[2]);
   If (ClSlct=[]) or (SmplClass in ClSlct) then ClustStepAkku(v,RefTab,SumTab);
   end;

  if strt then strt:=False
          else if DsplElli then DsplEllipsen(ClustTab);

  ClustStepCmpl(RefTab,SumTab,ClustTab);
  if DsplLabel then MarkCen(ClustTab);
  if DsplElli  then DsplEllipsen(ClustTab);
  ClustStepNewRef(ClustTab,RefTab,NewRef);
  RefTab:=NewRef;
  Inc(Count);
  if SnglStp then WaitforReturn;
  if KeyPressed then Exit;
 until ((NewClust=False) and (Wndrg<WndrgSchw)) or (Count>=MaxSteps);
 end;


procedure PlotElli(Alf:Real; Eiw:Vector_2; Cen:Vector_2);
 Const anzsteps=50; step=2*Pi/anzsteps;
 Var i:Word; t:Real; w,v:Vector_2; b,d,m,trm:Matrix_2; x,y,xv,yv,dx,dy:Integer;
 begin
 RotM(Alf,b); DiaM(2*Eiw[1],2*Eiw[2],d); SqrtMd(d,m); MulMM(b,m,Trm);

 if Eiw[1]>0.001 then
  begin
  if Eiw[2]=0 then
   begin
   SetV( 1,0,w); MulMV(trm,w,v); AddVV(Cen,v,v); MoveToV(v);
   SetV(-1,0,w); MulMV(trm,w,v); AddVV(Cen,v,v); LineToV(v);
   end
  else
   begin
   t:=0; SetV(cos(t),sin(t),w); MulMV(trm,w,v); AddVV(Cen,v,v);
   xv:=XS(XF(v[1])); yv:=YS(YF(v[2])); MoveTo(xv,yv);
   repeat
    begin
    repeat
     t:=t+step; SetV(cos(t),sin(t),w); MulMV(trm,w,v); AddVV(Cen,v,v);
     x:=XS(XF(v[1])); y:=YS(YF(v[2]));
    until (abs(x-xv)>1) or (abs(y-yv)>1);
    dx:=x-xv; if      dx>0 then Dec(dx)
              else if dx<0 then Inc(dx);
    xv:=x-dx;
    dy:=y-yv; if      dy>0 then Dec(dy)
              else if dy<0 then Inc(dy);
    yv:=y-dy;
    Line(xv,yv,x,y);
    xv:=x;
    yv:=y;
    end;
   until t>=2*Pi;
   end;
  end;
 end;


procedure PlotCircle(Cen:Vector_2; Radius:Real);
 Var rad:Word;
 begin
 rad:=XS(XF(Radius))-XS(XF(0));
 circle(XS(XF(Cen[1])),YS(YF(Cen[2])),rad);
 end;


procedure DsplEllipsen(ClustTab:ClustTab_T);
 Var i:Word;
 begin
 SetColor(ElliColor);
 SetWriteMode(XorPut);
 with ClustTab do for i:=1 to Anz do with dat[i] do PlotElli(Alf,Eiw,Cen);
 SetWriteMode(NormalPut);
 end;

procedure DsplKreise(ClustTab:ClustTab_T);
 Var i:Word;
 begin
 SetColor(ElliColor);
 SetWriteMode(XorPut);
 with ClustTab do for i:=1 to Anz do with dat[i] do PlotCircle(Cen,sqrt(Eiw[1]+Eiw[2]));
 SetWriteMode(NormalPut);
 end;


procedure ClustInit(Var RefTab:RefTab_T);
 begin
 with RefTab do   begin
                  Anz:=1;
                  SetV(0,0,Dat[1]);
                  end;
 end;


procedure ClrSumTab(RefTab:RefTab_T; Var SumTab:SumTab_T);
 Var i:Word;
 begin
 for i:=1 to RefTab.Anz do with SumTab[i] do
  begin
  Anz:=0; SetV(0,0,Suv); SetM(0,0,0,0,Sum);
  end;
 end;


procedure ClustStepAkku(v:Vector_2; RefTab:RefTab_T; Var SumTab:SumTab_T);
 Var i,imin:Word; d,dmin:Real; m:Matrix_2;
 begin
 imin:=1;
 with RefTab do 
  begin
  dmin:=1E+30;
  for i:=1 to Anz do
   begin
   d:=AbstqVV(v,dat[i]);
   if d<dmin then begin dmin:=d; imin:=i; end;
   end;
  with SumTab[imin] do
   begin Inc(Anz); AddVV(Suv,v,Suv); DyaVV(v,m); AddMM(Sum,m,Sum); end;
  end;
 end;




procedure ClustStepCmpl(RefTab:RefTab_T; SumTab:SumTab_T; Var ClustTab:ClustTab_T);
 Var
  i: Word;
  anzi: Real;
  m,k,d,b: Matrix_2;

 begin
 ClustTab.Anz:=RefTab.Anz;
 with ClustTab do
  begin
  for i:=1 to Anz do
   begin
   with Dat[i] do
    begin
    Anz:=SumTab[i].Anz;
    Alf:=0;
    SetV(0.0001,0.0001,Eiw);
    SetV(0,0,Cen);

    if Anz>=1 then begin
                   anzi:=1/anz;
                   MulSV(anzi,SumTab[i].Suv,Cen);
                   end;

    if anz>=2 then begin
                   MulSM(anzi,SumTab[i].Sum,m);
                   DyaVV(Cen,k);
                   SubMM(m,k,k);
                   EigMS(k,d,b);
                   AlpB(b,Alf);
                   Eiw[1]:=MaxR(d[1,1],0);
                   Eiw[2]:=MaxR(d[2,2],0);
                   end;
    end;
   end;
  end;
 end;


procedure ClustStepNewRef(ClustTab:ClustTab_T; RefTab:RefTab_T; Var NewRef:RefTab_T);
 Const
  Step=0.1;

 Var
  i: Word; bog:Real; len:Real;
  e1,ref,new: Vector_2;

 begin
 Wndrg:=0; NewClust:=FALSE; NewRef.Anz:=0;

 for i:=1 to ClustTab.Anz do
  begin
  SetColor(TreeColor);
  with ClustTab.Dat[i] do
   begin
   if Anz>=1 then
    begin
    ref:=RefTab.dat[i];
    if DsplTree then LineV(ref,Cen);
    if sqrt(Eiw[1]+Eiw[2])<=ClustSchw then
     begin
     if Anz/(Eiw[1]+Eiw[2])>SlctSchw then
      begin
      Wndrg:=MaxR(Wndrg,sqrt(AbstqVV(ref,Cen)));
      Inc(NewRef.Anz); NewRef.Dat[NewRef.Anz]:=Cen;
      end;
     end
    else
     begin
     if SeedEigVek then begin
                        bog:=Pi/180*Alf;
                        len:=Step*sqrt(Eiw[1]);
                        end
                   else begin
                        bog:=Pi*Random;
                        len:=Step*sqrt(Eiw[1]+Eiw[2]);
                        end;
     SetV(len*cos(bog),len*sin(bog),e1);
     AddVV(Cen,e1,new); if DsplTree then LineV(Cen,new);
     Inc(NewRef.Anz); NewRef.dat[NewRef.Anz]:=new;
     SubVV(Cen,e1,new); if DsplTree then LineV(Cen,new);
     Inc(NewRef.Anz); NewRef.dat[NewRef.Anz]:=new;
     NewClust:=TRUE;
     end;
    end;
   end;
  end;
 end;

procedure MarkCen(ClustTab:ClustTab_T);
 Var i:Word; v:Vector_2; c:Char;
 begin
 SetColor(LabelColor);
 with ClustTab do
  for i:=1 to Anz do begin
                     if i <10 then c:=Chr(i+48) else c:=Chr(i+55);
                     PlotSymbV(Dat[i].Cen,c);
                     end;
 end;


procedure WrClustTab(ClustSvDatei:PathStr; ClustTab:ClustTab_T);
 Var
  i,k:Word; f:text;
  r,mr,rr,rrm,aa,aam,d,md,exc,excm,anzm,frmd,mfrmd:Real;
 begin
 Assign(f,ClustSvDatei); Rewrite(f);

 writeln(f,'Clustertabelle');
 writeln(f);
 writeln(f,'Stichprobe : ',StchpRdDatei);
 writeln(f,'ClusterSchwelle fr die Teilung ......... : ',StrR(ClustSchw,7,3));
 writeln(f,'Wanderungsschwelle als Endekriterium .... : ',StrR(WndrgSchw,7,3));
 writeln(f,'Auswahlschwelle fr die Referenzenbildung : ',StrR(SlctSchw,7,3));
 writeln(f);
 writeln(f);

 mr:=0; md:=0; anzm:=0; excm:=0; rrm:=0; aam:=0; mfrmd:=0;
 writeln(f,'Cen    x      y            r      anz     d      exc   frmd');
 writeln(f,'------------------------------------------------------------');
           {123 123456 123456 123456 123456 123456 1234567 123456 123456}

 for i:=1 to ClustTab.Anz do with ClustTab.dat[i] do
  begin
  rr:=Eiw[1]+Eiw[2]; rrm:=rrm+rr; r:=sqrt(rr); mr:=mr+r;
  exc:=sqrt(Eiw[1]/MaxR(Eiw[2],0.0001)); excm:=excm+exc;
  frmd:=1.0E+30;
  for k:=1 to ClustTab.Anz do if k<>i then
   begin
   aa:=AbstqVV(Cen,ClustTab.Dat[k].Cen); aam:=aam+aa;
   frmd:=MinR(aa,frmd);
   end;
  frmd:=sqrt(frmd);
  mfrmd:=mfrmd+frmd;
  d:=Anz/rr; md:=md+d; anzm:=anzm+anz;
  writeln(f,i:3,
            Cen[1]:7:2,
            Cen[2]:7:2,
            Alf:7:2,
            r:7:2,
            Anz:7,
            d:8:2,
            exc:7:2,
            frmd:7:2);
  end;
 writeln(f,'------------------------------------------------------------');
           {123 123456 123456 123456 123456 123456 1234567 123456 123456}
 with ClustTab do
  begin
  if Anz>0 then
   begin
   writeln(f,'Mittelwerte             ',
             mr/Anz:7:2,
             round(anzm/Anz):7,
             md/Anz:8:2,
             excm/Anz:7:2,
             mfrmd/Anz:7:2);
   rrm:=rrm/Anz;
   if Anz>1 then aam:=aam/(Anz*(Anz-1)) else aam:=0;
   writeln(f);
   writeln(f,'Q-Ma = ',rrm/(aam+rrm):5:3);
   writeln(f,'Mittelwert(r)/Mittelwert(frmd) = ',mr/mfrmd:5:3);
   end;
  end;
 Close(f);
 end;



procedure ShowStars(ClustTab:ClustTab_T);
 Var i,imin:Word; d,dmin:Real;
 begin
 Reset(StchpRdFile);
 while not Eof(StchpRdFile) do
  begin
  ReadLn(StchpRdFile,SmplClass,SmplNr,v[1],v[2]);
  If (ClSlct=[]) or (SmplClass in ClSlct) then

   begin
   imin:=1;
   with ClustTab do 
    begin
    dmin:=1E+30;
    for i:=1 to Anz do
     begin
     d:=AbstqVV(v,Dat[i].Cen);
     if d<dmin then begin dmin:=d; imin:=i; end;
     end;
    SetColor(StarColor);
    LineV(v,Dat[imin].Cen);
    end;
   end;

  end;
 end;

procedure GenStMod(ClustTab:ClustTab_T; Var StMod:StMod_T);
 Const dontcare='-';
 Var   i:Word; sum:Real;
 begin
 with StMod do
  begin
  anz:=ClustTab.Anz;
  anzcl:=1;
  sum:=0;
  for i:=1 to anz do with tab[i] do
   begin
   if i=1 then begin class:='*';      cprob:=1.0; anzsc:=anz; end
          else begin class:=dontcare; cprob:=0.0; anzsc:=0;   end;
   if i <10 then sbcls:=Chr(i+48) else sbcls:=Chr(i+55);
   scprb:=ClustTab.dat[i].Anz; sum:=sum+scprb;
   meanx:=ClustTab.dat[i].Cen[1];
   meany:=ClustTab.dat[i].Cen[2];
   alpha:=ClustTab.dat[i].Alf;
   eigv1:=ClustTab.dat[i].Eiw[1];
   eigv2:=ClustTab.dat[i].Eiw[2];
   end;
  for i:=1 to anz do with tab[i] do scprb:=scprb/sum;
  end;
 end;

begin
end.