unit JS_DCSP;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_koor,js_stm,js_mtr,js_gra,js_nnt;


Type
 ProjMatrix_T = array [1..2,1..AnzElemMod] of Real;
 ColorLst_T =   array [32..255] of Byte;

Var
 DVektRdFile:   Text;
 ProjMatrix:    ProjMatrix_T;
 DVkt:          DVkt_T;
 KEckColor:     Word;
 KEckLineStyle: Word;
 NetzColor:     Word;
 NetzLineStyle: Word;
 ColorLst:      ColorLst_T;
 SrcDVekt:      Boolean;
 RdDatei:       PathStr;
 ProjInDcsp:    Boolean;



procedure PfadeInitDecSp(PfadeMaske: MskPar_T);
procedure ColorInitDecSp(FarbeMaske:MskPar_T);

procedure ProjMatrixInit;
procedure ProjInDecSpace(Var DVkt:DVkt_t);
procedure Proj(DVkt:DVkt_T; Var v:Vector_2);
procedure Zielvektor(k:Word; Var y:Dvkt_T);
procedure PlotKEck;

procedure Linie(k:Word; w:Real);
procedure PlotDreiKlassenNetz;

procedure ColorListInit(ClSlct:SetChar_T; Var ColorLst:ColorLst_T);



Implementation

procedure PfadeInitDecSp(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=   PfadeMaske.erg[ 1];
 KoorRdDflt:= PfadeMaske.erg[ 2];
 FarbePfad:=  PfadeMaske.erg[ 3];
 FarbeRdDflt:=PfadeMaske.erg[ 4];
 DVektPfad:=  PfadeMaske.erg[ 5];
 KlfPfad:=    PfadeMaske.erg[ 6];
 NntPfad:=    PfadeMaske.erg[ 7];
 ZKlfPfad:=   PfadeMaske.erg[ 8];
 ZRdbPfad:=   PfadeMaske.erg[ 9];
 StchpPfad:=  PfadeMaske.erg[10];
 CnfPfad:=    PfadeMaske.erg[11];
 EditorPfad:= PfadeMaske.erg[12];

 KoorRdDatei:= KoorRdDflt;
 FarbeRdDatei:=FarbeRdDflt;
 end;


procedure ColorInitDecSp(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 KEckColor:=         ColorFromStr(FarbeMaske.erg[4]);
 KEckLineStyle:=     ValI(Trim(FarbeMaske.erg[5]));
 NetzColor:=         ColorFromStr(FarbeMaske.erg[6]);
 NetzLineStyle:=     ValI(Trim(FarbeMaske.erg[7]));
 end;




procedure ProjMatrixInit;
 Const start=Pi/2;
 Var   k:Word;
       delta:Real;
 begin
 delta:=2*Pi/KlAnz;
 for k:=1 to KlAnz do
  begin
  ProjMatrix[1,k]:=cos(start+(k-1)*delta);
  ProjMatrix[2,k]:=sin(start+(k-1)*delta);
  end;
 end;


procedure ProjInDecSpace(Var DVkt:DVkt_t);
 Var k:Word; sum,alpha:Real;
 begin
 sum:=0; for k:=1 to KlAnz do sum:=sum+DVkt[k];
 alpha:=(1-sum)/Klanz;

 for k:=1 to KlAnz do DVkt[k]:=DVkt[k]+alpha;
 end;


procedure Proj(DVkt:DVkt_t; Var v:Vector_2);
 Var k:Word;
 begin
 v[1]:=0; for k:=1 to KlAnz do v[1]:=v[1]+ProjMatrix[1,k]*DVkt[k];
 v[2]:=0; for k:=1 to KlAnz do v[2]:=v[2]+ProjMatrix[2,k]*DVkt[k];
 end;


procedure Zielvektor(k:Word; Var y:Dvkt_T);
 Var i:Word;
 begin
 for i:=1 to KlAnz do if i=k then y[i]:=1 else y[i]:=0;
 end;


procedure PlotKEck;
 Var y:Dvkt_T; v,v1:Vector_2;
     k:Word;
 begin
 Zielvektor(1,y); Proj(y,v); LMoveToV(v);
 v1:=v;
 for k:=2 to KlAnz do begin Zielvektor(k,y); Proj(y,v); LLineToV(v); end;
 LLineToV(v1);
 end;


procedure Linie(k:Word; w:Real);
 Var anfg,ende:DVkt_T; v:Vector_2; i,j:Word;
 begin
 if KlAnz<>3 then Exit;
 for i:=0 to 2 do
  begin
  j:=((k+i-1) mod 3)+1;
  case i of
   0: begin anfg[j]:=w;   ende[j]:=w;   end;
   1: begin anfg[j]:=1-w; ende[j]:=0;   end;
   2: begin anfg[j]:=0;   ende[j]:=1-w; end;
  end;
  end;
 Proj(anfg,v); LMoveToV(v);
 Proj(ende,v); LLineToV(v);
 end;


procedure PlotDreiKlassenNetz;
 Const n=5;
       del=1/n;
 Var   k,i:Word;
 begin
 for k:=1 to KlAnz do for i:=1 to n-1 do Linie(k,i*del);
 end;

procedure ColorListInit(ClSlct:SetChar_T; Var ColorLst:ColorLst_T);
 Const ColorDflt=Red;
 Var   i,j:Word;
 begin
 j:=0;
 for i:=32 to 255 do
  if Chr(i) in ClSlct then begin
                           ColorLst[i]:=ClassColor[j mod 12];
                           Inc(j);
                           end
                      else ColorLst[i]:=ColorDflt;
 end;

begin
end.