unit JS_KOOR;

Interface

Uses
 graph,dos,crt,js_gra,js_sub,js_tio,js_acc,js_mtr;

Type                                   
 ZchFld_T=(scrn,hcop);
 mlog_T=set of 1..9;
 Koor_T=record
         uh,uv: Real;        {Position des Koordinatenursprungs}
         ux,uy: Real;        {Werte am Koordinatenursprung     }
         dh,dv: Real;        {Schrittweite der Achsenteilung   }
         dx,dy: Real;        {zugehrige X- und Y-Inkremente   }
         sx,sy: Byte;        {jeder s-e Abschnitt beschriftet  }
         nx,mx,ny,my: Byte;  {Formatierungsparameter           }
         tx,ty: string[79];  {Achsenbeschriftung               }
         rstr:Byte;          {Rasterlinien 0,1,2               }
         sclv,sclh: Real;    {Mastab Koordinatensystem -> Zeichenfeld}
         logx,logy: Boolean; {logarithmische Teilung           }
         mlgx,mlgy: mlog_T;  {Markierungen bei Log-Skala       }
         lmtl,lmtr: Real;    {linker, rechter Rand in x        }
         lmtu,lmto: Real;    {unterer, oberer Rand in y        }
        end;


VAR
 PmmH,PmmV: Real;           {Mastab Pixel pro Millimeter     }
 ZchFld:ZchFld_T;           {Zeichenfeld-Type Bildschirm/Drucker}
 ZchFldH,ZchFldV: Real;     {Zeichenfeld Abmessungen in mm    }
 Koor:Koor_T;

procedure ZchFldInit;
function  ZchFldStr(ZchFld:ZchFld_T):string;
function  XS(xf:real):integer;
function  XSInv(xs:Integer):Real;
function  YS(yf:real):integer;
function  YSInv(ys:Integer):Real;
procedure KoorPlot(Koor:Koor_T);
procedure KoorInit(KoorPar:StrFld_T; Var Koor:Koor_T);

function  XF(x:real):real;
function  XFInv(xf:real):real;
function  YF(y:real):real;
function  YFInv(yf:real):real;

function  ChckInFldV(v:Vector_2):Boolean;
procedure PlotV(v:Vector_2; farbe:Word);
procedure PlotSymbV(v:Vector_2; ch:Char);
procedure MoveToV(v:Vector_2);
procedure LineToV(v:Vector_2);
procedure LineV(v1,v2:Vector_2);
procedure LMoveToV(v:Vector_2);
procedure LLineToV(v:Vector_2);
procedure LMoveToVChck(v:Vector_2; nr1,nr2:Word;Chck:ChckF_T);
procedure LLineToVChck(v:Vector_2; nr1,nr2:Word;Chck:ChckF_T);


Implementation

procedure ZchFldInit;
 begin
 case ZchFld of
  hcop: begin PmmH:=120/25.4;   PmmV:=72/25.4;    end;
  scrn: begin PmmH:=AnzPxH/290; PmmV:=AnzPxV/215; end;
 end;
 ZchFldH:=AnzPxH/PmmH; ZchFldV:=AnzPxV/PmmV;
 end;


function ZchFldStr(ZchFld:ZchFld_T):string;
 const s: array [ZchFld_T] of string[6] = ('SCREEN','HDCOPY');
 begin ZchFldStr:=s[ZchFld]; end;


function XS(xf:real):integer;
 begin XS:=round(PmmH*xf); end;

function XSInv(xs:Integer):Real;
 begin XSInv:=xs/PmmH; end;

function YS(yf:real):integer;
 begin YS:=AnzPxV-round(PmmV*yf); end;

function YSInv(ys:Integer):Real;
 begin YSInv:=(AnzPxV-ys)/PmmV; end;


function XF(x:real):real;
 begin with Koor do
  begin
  if logx then if x<=0 then x:=0 else x:=log(x,10);
  XF:=uh+sclh*(x-ux);
  end;
 end;

function XFInv(xf:real):real;
 Var x:Real;
 begin with Koor do
  begin
  x:=(xf-uh)/sclh+ux;
  if logx then x:=XhochY(10,x);
  XFInv:=x;
  end;
 end;

function YF(y:real):real;
 begin with Koor do
  begin
  if logy then if y<=0 then y:=0 else y:=log(y,10);
  YF:=uv+sclv*(y-uy);
  end;
 end;

function YFInv(yf:real):real;
 Var y:Real;
 begin with Koor do
  begin
  y:=(yf-uv)/sclv+uy;
  if logy then y:=XhochY(10,y);
  YFInv:=y;
  end;
 end;


function  ChckInFldV(v:Vector_2):Boolean;
 begin
 with Koor do ChckInFldV:=((v[1]>=lmtl) and
                           (v[1]<=lmtr) and
                           (v[2]>=lmtu) and
                           (v[2]<=lmto));
 end;


procedure PlotV(v:Vector_2; farbe:Word);
 begin PutPixel(XS(XF(v[1])),YS(YF(v[2])),farbe); end;

procedure PlotSymbV(v:Vector_2; ch:Char);
 Var ti: TextSettingsType;
 begin
 GetTextSettings(ti);
 SetTextJustify(CenterText, CenterText);
 OutTextXY(XS(XF(v[1])),YS(YF(v[2])),ch);
 SetTextJustify(ti.horiz,ti.vert);
 end;

procedure MoveToV(v:Vector_2);
 begin MoveTo(XS(XF(v[1])),YS(YF(v[2]))); end;

procedure LineToV(v:Vector_2);
 begin LineTo(XS(XF(v[1])),YS(YF(v[2]))); end;

procedure LMoveToV(v:Vector_2);
 begin LMoveTo(XS(XF(v[1])),YS(YF(v[2]))); end;

procedure LLineToV(v:Vector_2);
 begin LLineTo(XS(XF(v[1])),YS(YF(v[2]))); end;

procedure LMoveToVChck(v:Vector_2; nr1,nr2:Word;Chck:ChckF_T);
 begin LMoveToChCk(XS(XF(v[1])),YS(YF(v[2])),nr1,nr2,Chck); end;

procedure LLineToVChck(v:Vector_2; nr1,nr2:Word;Chck:ChckF_T);
 begin LLineToChck(XS(XF(v[1])),YS(YF(v[2])),nr1,nr2,Chck); end;


procedure LineV(v1,v2:Vector_2);
 begin Line(XS(XF(v1[1])),YS(YF(v1[2])),XS(XF(v2[1])),YS(YF(v2[2]))); end;


procedure KoorPlot(Koor:Koor_T);
 Var
  savefg,savebk,color: Word;
  x,y,xl,yl: Real;
  i:Integer;
  mark:Boolean; 

 Const
  strich: array[Boolean] of Integer=(1,2);

 procedure GridLineV(x:Real);
  begin
  SetLineStyle(DottedLn,0,NormWidth);
  MoveTo(XS(XF(x)),YS( 0)); LineTo(XS(XF(x)),YS(ZchFldV));
  SetLineStyle(SolidLn,0,NormWidth);
  end;

 procedure GridLineH(y:Real);
  begin
  SetLineStyle(DottedLn,0,NormWidth);
  MoveTo(XS( 0),YS(YF(y))); LineTo(XS(ZchFldH),YS(YF(y)));
  SetLineStyle(SolidLn,0,NormWidth);
  end;

 procedure BeschrifteH(x:Real);
  begin
  with Koor do WriteXYG(XS(XF(x))-(nx-mx-1)*8,YS(uv-3),StrR(x,nx,mx));
  end;

 procedure BeschrifteV(y:Real);
  begin
  with Koor do WriteXYG(XS(uh-3)-ny*8,YS(YF(y))-4,StrR(y,ny,my));
 end;


 begin
 color:=GetColor; savebk:=TxtBckGr; savefg:=TxtForGr;
 TextBackGround(DskTpColor[ActPage]); TextColor(color);

 with Koor do
  begin

  {Achsenkreuz}
   SetLineStyle(SolidLn,0,NormWidth);
   x:=0;  y:=uv; MoveTo(XS(x),YS(y));
   x:=ZchFldH;   LineTo(XS(x),YS(y));
   x:=uh; y:=0;  MoveTo(XS(x),YS(y));
   y:=ZchFldH;   LineTo(XS(x),YS(y));

  {Teilung und Beschriftung X }
   if logx then
    begin
    {logarithmische Skala}
     x:=XHochY(10,ux); i:=2;
     while x<=XHochY(10,lmtr) do
      begin
      xl:=i*x;
      if i=10 then begin
                   GridLineV(xl);
                   BeschrifteH(xl);
                   x:=10*x; i:=1;
                   end;
      if i in mlgx then begin
                   MoveTo(XS(XF(xl)),YS(uv));
                   LineTo(XS(XF(xl)),YS(uv-strich[TRUE]));
                   end;
      Inc(i);
      end;
    end
   else
    begin
    {lineare Skala}
     i:=-trunc(uh/dh);
     while i<=trunc((ZchFldH-uh)/dh) do
      begin
      mark:=((i mod sx)=0);
      x:=ux+i*dx;
      MoveTo(XS(XF(x)),YS(uv));
      LineTo(XS(XF(x)),YS(uv-strich[mark]));
      if rstr=2 then GridLineV(x);
      if mark then begin
                   if rstr>0 then GridLineV(x);
                   BeschrifteH(x);
                   end;
      Inc(i);
      end;
    end;

   {Teilung und Beschriftung Y }
    if logy then
    begin
    {logarithmische Skala}
     y:=XHochY(10,uy); i:=2;
     while y<=XHochY(10,lmto) do
      begin
      yl:=i*y;
      if i=10 then begin
                   GridLineH(yl);
                   BeschrifteV(yl);
                   y:=10*y; i:=1;
                   end;
      if i in mlgy then begin
                        MoveTo(XS(uh),YS(YF(yl)));
                        LineTo(XS(uh-strich[TRUE]),YS(YF(yl)));
                        end;
      Inc(i);
      end;
    end
   else
    begin
    {lineare Skala}
     i:=-trunc(uv/dv);
     while i<=trunc((ZchFldV-uv)/dv) do
      begin
      mark:=((i mod sy)=0);
      y:=uy+i*dy;
      MoveTo(XS(uh),YS(YF(y)));
      LineTo(XS(uh-strich[mark]),YS(YF(y)));
      if rstr=2 then GridLineH(y);
       if mark then begin
                    if rstr>0 then GridLineH(y);
                    BeschrifteV(y);
                    end;
      Inc(i);
      end;
     end;

    {Achsenbeschriftung}
     WriteXYG(XS(ZchFldH)-length(tx)*8,YS(uv-9),tx);
     WriteXYG(XS(uh+5),YS(ZchFldV),ty);
    end;

 TextBackGround(savebk); TextColor(savefg);
 end;


procedure KoorInit(KoorPar: StrFld_T; Var Koor:Koor_T);
 var i:Byte; s:string;
 begin
 with Koor do
  begin
  uh:=VALR(Trim(KoorPar[ 1])); uv:=VALR(Trim(KoorPar[ 2]));
  ux:=VALR(Trim(KoorPar[ 3])); uy:=VALR(Trim(KoorPar[ 4]));
  dh:=VALR(Trim(KoorPar[ 5])); dv:=VALR(Trim(KoorPar[ 6]));
  dx:=VALR(Trim(KoorPar[ 7])); dy:=VALR(Trim(KoorPar[ 8]));
  sx:=VALI(Trim(KoorPar[ 9])); sy:=VALI(Trim(KoorPar[10]));
  nx:=VALI(Trim(KoorPar[11])); mx:=VALI(Trim(KoorPar[12]));
  ny:=VALI(Trim(KoorPar[13])); my:=VALI(Trim(KoorPar[14]));
  tx:=Trim(KoorPar[15]);       ty:=Trim(KoorPar[16]);
  rstr:=VALI(Trim(KoorPar[17]));
  s:=Trim(KoorPar[18]);
   mlgx:=[]; for i:=1 to length(s) do mlgx:=mlgx+[ValI(s[i])];
   logx:=(mlgx<>[]);
  s:=Trim(KoorPar[19]);
   mlgy:=[]; for i:=1 to length(s) do mlgy:=mlgy+[ValI(s[i])];
   logy:=(mlgy<>[]);
  sclh:=dh/dx; sclv:=dv/dy;
  lmtl:=ux-uh/sclh; lmtr:=ux+(ZchFldH-uh)/sclh;
  if logx then begin lmtl:=XHochY(10,lmtl); lmtr:=XHochY(10,lmtr); end;
  lmtu:=uy-uv/sclv; lmto:=uy+(ZchFldV-uv)/sclv;
  if logy then begin lmto:=XHochY(10,lmto); lmtu:=XHochY(10,lmtu); end;
  end;
 end;



begin
end.