unit JS_MDLH;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_tio,js_koor,
 js_stm,js_mtr,js_mat,js_gra,js_qmx,js_glbw;


Const
 MaxAnzClust=50;


Type
 Hist_T = array [1..AnzIntv] of Real;

 ClustRec_T = record
               M0,M1,M2:Real;
              end;

 ClustTab_T = record
               Anz: Word;
               Dat: Array [1..MaxAnzClust] of ClustRec_T;
              end;

 GrenzRec_T = record
               Ind: Word;
               Ref: Real;
              end;

 GrenzTab_T = record
               Anz: Word;
               Dat: Array [1..MaxAnzClust+1] of GrenzRec_T;
              end;


Const
 ParGlbwModInit:ParGlbwMod_T = (0.0,0.1,0.3,0.7,0.9,1.0);
 OptStepGradInit = 0.1;
 SimFakGradInit  = 1.0;
 OptStepGradMin  = 0.1*OptStepGradInit;
 OptStepRandInit = 0.02;
 SimFakRandInit  = 0.95;
 OptStepRandMin  = 0.01*OptStepRandInit;
 LimitGradInit   = 5E-4;


Var
 HistColor:        Word;
 HistLineStyle:    Word;
 NvtColor:         Word;
 ApproxColor:      Word;
 ApproxLineStyle:  Word;
 GlbwColor:        Word;
 GlbwLineStyle:    Word;
 ClustSchw:        Real;
 WndrgSchw:        Real;
 NewClust:         Boolean;
 Wndrg:            Real;
 DsplApp:          Boolean;
 DsplNvt:          Boolean;
 DsplErr:          Boolean;
 GlFaktor:         Real;
 HistogrFertig:    Boolean;
 ModEigFertig:     Boolean;
 ModFrmFertig:     Boolean;
 AnzClust:         Word;
 Merr:             Real;
 Rmse:             Real;
 FakGlbw:          Real;

 HistEig:          Hist_T;
 HistFrm:          Hist_T;
 HistGlbw:         Hist_T;
 HistGlbwFertig:   Boolean;
 HistEigFrmFertig: Boolean;
 FiltPar:          Integer;
 IncGlbwColor:     Boolean;
 AktGlbwColor:     Word;
 OptStepRand:      Real;
 OptStepGrad:      Real;
 OptStepGradMax:   Real;
 SimFakRand:       Real;
 SimFakGrad:       Real;
 DsplOpt:          Boolean;
 PrtkOpt:          Boolean;
 SumEig:           Real;
 SumFrm:           Real;
 LimitGrad:        Real;

 ClustLstPfad,                      ClustLstSvDatei: PathStr;


procedure PfadeInitMdl(PfadeMaske:MskPar_T);
procedure ColorInitMdl(FarbeMaske:MskPar_T);

procedure PlotGetEigFrmHist(SlctLabel:Char; HistType:Byte; Var Histogr:Hist_T);
procedure ClrHist(Var Histogr:Hist_T);
procedure PlotHist(Histogr:Hist_T; Color,LineStyle:Word);
procedure PlotHistFkt(Histogr:Hist_T; Color,LineStyle:Word);

procedure PlotBasisFkt(M0,M1,M2:Real);
procedure DsplNvts(ClustTab:ClustTab_T);
function  AppFkt(x:Real; ClustTab:ClustTab_T):Real;
procedure PlotApproxFkt(ClustTab:ClustTab_T);
procedure PlotAppFkt(ClustTab:ClustTab_T);
procedure PlotGlbwFkt(ClustTabEig,ClustTabFrm:ClustTab_T);


procedure ClustInit(Var GrenzTab:GrenzTab_T);
procedure ClustStep(Histogr:Hist_T; GrenzTab:GrenzTab_T; Var ClustTab:ClustTab_T);
procedure ClustStepNewGrenz(ClustTab:ClustTab_T; GrenzTab:GrenzTab_T; Var NewGrenz:GrenzTab_T);

procedure GoThru(Histogr:Hist_T; Var GrenzTab:GrenzTab_T; Var ClustTab:ClustTab_T; Var NewGrenz:GrenzTab_T);

procedure EvalApproxFkt(Histogr:Hist_T; ClustTab:ClustTab_T; Var AnzClust:Word; Var Merr,Rmse:Real);
procedure DsplError(AnzClust:Word; Merr,Rmse:Real);
procedure WrClustLst(ClustLstSvDatei:PathStr; ClustTab:ClustTab_T; GrenzTab:GrenzTab_T);

procedure GetEigFrmHist(SlctLabel:Char);
procedure MakeHistGlbw;
procedure PlotGlbwFromHistGlbw;
procedure FiltHistAver(Par:Word; He:Hist_T; Var Ha:Hist_T);
procedure FiltHistGauss(Par:Word; He:Hist_T; Var Ha:Hist_T);
procedure FiltHistMedian(Par:Word; He:Hist_T; Var Ha:Hist_T);

procedure PlotGlbwModell;
 function SumHist(Hist:Hist_T):Real;
 function CheckMatchGlbwMod:Real;
procedure OptimGlbwMod;
procedure GradVektFehlerFkt(Var GradVektFehler:ParGlbwMod_T);
procedure OptimGlbwModGradAbstieg;



Implementation

procedure PfadeInitMdl(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=     PfadeMaske.erg[ 1];
 KoorRdDflt:=   PfadeMaske.erg[ 2];
 FarbePfad:=    PfadeMaske.erg[ 3];
 FarbeRdDflt:=  PfadeMaske.erg[ 4];
 HistPfad:=     PfadeMaske.erg[ 5];
 ClustLstPfad:= PfadeMaske.erg[ 6];
 EditorPfad:=   PfadeMaske.erg[ 7];

 KoorRdDatei:=   KoorRdDflt;
 FarbeRdDatei:=  FarbeRdDflt;
 end;


procedure ColorInitMdl(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 EigHistColor:=      ColorFromStr(FarbeMaske.erg[4]);
 EigHistLineStyle:=  ValI(Trim(FarbeMaske.erg[5]));
 FrmHistColor:=      ColorFromStr(FarbeMaske.erg[6]);
 FrmHistLineStyle:=  ValI(Trim(FarbeMaske.erg[7]));
 HistColor:=         ColorFromStr(FarbeMaske.erg[8]);
 HistLineStyle:=     ValI(Trim(FarbeMaske.erg[9]));
 NvtColor:=          ColorFromStr(FarbeMaske.erg[10]);
 ApproxColor:=       ColorFromStr(FarbeMaske.erg[11]);
 ApproxLineStyle:=   ValI(Trim(FarbeMaske.erg[12]));
 GlbwColor:=         ColorFromStr(FarbeMaske.erg[13]);
 GlbwLineStyle:=     ValI(Trim(FarbeMaske.erg[14]));
 FakGlbw:=           ValR(Trim(FarbeMaske.erg[15]));
 end;


procedure PlotGetEigFrmHist(SlctLabel:Char; HistType:Byte; Var Histogr:Hist_T);
 Var v:Vector_2; n,k,kk:Word; x,h:Real; eps:Real;
 begin
 if SlctLabel=#32 then k:=0
                  else begin
                       k:=1;
                       while not (ClsLst[k]=SlctLabel) do Inc(k);
                       end;
 x:=Xanf+0.5*XDel; eps:=0.2*XDel;
 for n:=1 to AnzIntv do
  begin
  Histogr[n]:=0;
  if HistType in [0,2] then begin
                            SetColor(EigHistColor);
                            l_art:=LMuster[EigHistLineStyle];
                            SetV(x+eps,0,v); LMoveToV(v);
                            if k=0 then begin
                                        h:=0;
                                        for kk:=1 to KlAnz do h:=h+Hist^[n,kk,1];
                                        h:=h/KlAnz;
                                        end
                                   else h:=Hist^[n,k,1];
                            SetV(x+eps,h,v); LLineToV(v);
                            Histogr[n]:=Histogr[n]+h;
                            end;
  if HistType in [1,2] then begin
                            SetColor(FrmHistColor);
                            l_art:=LMuster[FrmHistLineStyle];
                            SetV(x-eps,0,v); LMoveToV(v);
                            if k=0 then begin
                                        h:=0;
                                        for kk:=1 to KlAnz do h:=h+Hist^[n,kk,2];
                                        h:=h/KlAnz;
                                        end
                                   else h:=Hist^[n,k,2];
                            SetV(x-eps,h,v); LLineToV(v);
                            Histogr[n]:=Histogr[n]+h;
                            end;
  x:=x+XDel;
  end;
 end;

procedure ClrHist(Var Histogr:Hist_T);
 Var n:Word;
 begin
 for n:=1 to AnzIntv do Histogr[n]:=0;
 end;



procedure PlotHist(Histogr:Hist_T; Color,LineStyle:Word);
 Var v:Vector_2; n:Word; x:Real;
 begin
 SetColor(Color);
 l_art:=LMuster[LineStyle];
 x:=Xanf+0.5*XDel;
 for n:=1 to AnzIntv do
  begin
  SetV(x,0,v); LMoveToV(v); SetV(x,Histogr[n],v); LLineToV(v);
  x:=x+XDel;
  end;
 end;


procedure PlotHistFkt(Histogr:Hist_T; Color,LineStyle:Word);
 Var v:Vector_2; n:Word; x:Real;
 begin
 SetColor(Color);
 l_art:=LMuster[LineStyle];
 x:=Xanf+0.5*XDel;
 SetV(x,Histogr[1],v); LMoveToV(v);
 x:=x+XDel;
 for n:=2 to AnzIntv do
  begin
  SetV(x,Histogr[n],v); LLineToV(v);
  x:=x+XDel;
  end;
 end;



procedure ClustInit(Var GrenzTab:GrenzTab_T);
 begin
 with GrenzTab do begin
                  Anz:=1;
                  Dat[1].Ind:=1;
                  Dat[1].Ref:=(AnzIntv+1)/2;
                  Dat[2].Ind:=AnzIntv+1;
                  end;
 end;


procedure ClustStep(Histogr:Hist_T; GrenzTab:GrenzTab_T; Var ClustTab:ClustTab_T);
 Var n,m:Word; 
 begin
 with GrenzTab do
  begin
  for n:=1 to Anz do
   begin
   ClustTab.Dat[n].M0:=0;
   ClustTab.Dat[n].M1:=0;
   ClustTab.Dat[n].M2:=0;
   for m:=Dat[n].Ind to Dat[n+1].Ind-1 do
    begin
    ClustTab.Dat[n].M0:=ClustTab.Dat[n].M0+       Histogr[m];
    ClustTab.Dat[n].M1:=ClustTab.Dat[n].M1+    m* Histogr[m];
    ClustTab.Dat[n].M2:=ClustTab.Dat[n].M2+sqr(m)*Histogr[m];
    end;
   if ClustTab.Dat[n].M0>0 then
    begin
    ClustTab.Dat[n].M1:=ClustTab.Dat[n].M1/ClustTab.Dat[n].M0;
    ClustTab.Dat[n].M2:=sqrt(ClustTab.Dat[n].M2/ClustTab.Dat[n].M0-sqr(ClustTab.Dat[n].M1));
    end;
   end;
  ClustTab.Anz:=Anz;
  end;
 end;


procedure ClustStepNewGrenz(ClustTab:ClustTab_T; GrenzTab:GrenzTab_T; Var NewGrenz:GrenzTab_T);
 Var
  i: Word; ref:Real; new:Word;

 begin
 Wndrg:=0; NewClust:=False;
 NewGrenz.Anz:=0; NewGrenz.Dat[1].Ind:=1;

 for i:=1 to ClustTab.Anz do
  begin
  with ClustTab.Dat[i] do if M0>0 then
   begin
   if M2<=ClustSchw then
    begin
    Wndrg:=MaxR(Wndrg,abs(M1-GrenzTab.Dat[i].ref));
    Inc(NewGrenz.Anz);
    if i<ClustTab.Anz then NewGrenz.Dat[NewGrenz.Anz+1].Ind:=round((M1+ClustTab.Dat[i+1].M1)/2)
                      else NewGrenz.Dat[NewGrenz.Anz+1].Ind:=GrenzTab.Dat[i+1].Ind;
    NewGrenz.Dat[NewGrenz.Anz].Ref:=M1;
    end
   else
    begin
    new:=round(M1);
    Inc(NewGrenz.Anz);
    NewGrenz.Dat[NewGrenz.Anz+1].Ind:=new;
    NewGrenz.Dat[NewGrenz.Anz].Ref:=(NewGrenz.Dat[NewGrenz.Anz].Ind+new)/2;
    Inc(NewGrenz.Anz);
    NewGrenz.Dat[NewGrenz.Anz+1].Ind:=GrenzTab.Dat[i+1].Ind;
    NewGrenz.Dat[NewGrenz.Anz].Ref:=(new+GrenzTab.Dat[i+1].Ind)/2;
    NewClust:=True;
    end;
   end;
  end;
 end;



procedure PlotBasisFkt(M0,M1,M2:Real);
 Var x,f,fak,mean,sigm:Real;
 begin
 fak:=M0*Xdel; mean:=Xanf+(M1-0.5)*Xdel; sigm:=(M2+1)*Xdel*GlFaktor;
 x:=Xanf;
 f:=fak*WdNvt(x,mean,sigm);
 SetV(x,f,v); MoveToV(v);
 repeat
  x:=x+Xdel;
  f:=fak*WdNvt(x,mean,sigm);
  SetV(x,f,v); LineToV(v);
 until x>Xend;
 end;



procedure DsplNvts(ClustTab:ClustTab_T);
 Var i:Word;
 begin
 SetColor(NvtColor);
 SetWriteMode(XorPut);
 with ClustTab do for i:=1 to Anz do with Dat[i] do PlotBasisFkt(M0,M1,M2);
 SetWriteMode(NormalPut);
 end;


function  AppFkt(x:Real; ClustTab:ClustTab_T):Real;
 Var f:Real; i:Word; fak,mean,sigm:Real;
 begin
 with ClustTab do
  begin
  f:=0;
  for i:=1 to Anz do with Dat[i] do
   begin
   fak:=M0*Xdel; mean:=Xanf+(M1-0.5)*Xdel; sigm:=(M2+1)*Xdel*GlFaktor;
   f:=f+fak*WdNvt(x,mean,sigm);
   end;
  AppFkt:=f;
  end;
 end;



procedure PlotApproxFkt(ClustTab:ClustTab_T);
 Var x:Real;
 begin
 SetColor(ApproxColor);
 SetWriteMode(XorPut);
 x:=Xanf;
 SetV(x,AppFkt(x,ClustTab),v); MoveToV(v);
 repeat
  x:=x+Xdel;
  SetV(x,AppFkt(x,ClustTab),v); LineToV(v);
 until x>Xend;
 SetWriteMode(NormalPut);
 end;


procedure PlotAppFkt(ClustTab:ClustTab_T);
 Var x:Real;
 begin
 x:=Xanf;
 SetV(x,AppFkt(x,ClustTab),v); LMoveToV(v);
 repeat
  x:=x+Xdel;
  SetV(x,AppFkt(x,ClustTab),v); LLineToV(v);
 until x>Xend;
 end;


procedure PlotGlbwFkt(ClustTabEig,ClustTabFrm:ClustTab_T);
 Var x,eig,frm,nenner,glbw:Real;
 begin
 x:=Xanf;
 eig:=AppFkt(x,ClustTabEig);
 frm:=AppFkt(x,ClustTabFrm);
 nenner:=eig+frm;
 if nenner>0 then glbw:=eig/nenner else glbw:=0;
 SetV(x,FakGlbw*glbw,v); LMoveToV(v);
 repeat
  x:=x+Xdel;
  eig:=AppFkt(x,ClustTabEig);
  frm:=AppFkt(x,ClustTabFrm);
  nenner:=eig+frm;
  if nenner>0 then glbw:=eig/nenner else glbw:=0;
  SetV(x,FakGlbw*glbw,v); LLineToV(v);
 until x>Xend;
 end;



procedure GoThru(Histogr:Hist_T; Var GrenzTab:GrenzTab_T; Var ClustTab:ClustTab_T; Var NewGrenz:GrenzTab_T);
 Var strt:Boolean;
 begin
 strt:=True;
 ClustInit(GrenzTab);
 repeat

  if strt then strt:=False
          else begin
               if DsplNvt then DsplNvts(ClustTab);
               if DsplApp then PlotApproxFkt(ClustTab);
                end;

  ClustStep(Histogr,GrenzTab,ClustTab);
  if DsplNvt then DsplNvts(ClustTab);
  if DsplErr then begin
                  EvalApproxFkt(Histogr,ClustTab,AnzClust,Merr,Rmse);
                  DsplError(AnzClust,Merr,Rmse);
                  end;
  if DsplApp then begin
                  EvalApproxFkt(Histogr,ClustTab,AnzClust,Merr,Rmse);
                  PlotApproxFkt(ClustTab);
                  end;

  ClustStepNewGrenz(ClustTab,GrenzTab,NewGrenz);
  GrenzTab:=NewGrenz;
  if SnglStp then WaitforReturn;
  if KeyPressed then Exit;
 until (NewClust=False) and (Wndrg<WndrgSchw);
 end;


procedure EvalApproxFkt(Histogr:Hist_T; ClustTab:ClustTab_T; Var AnzClust:Word; Var Merr,Rmse:Real);
 Var x,f,err,sum1,sum2:Real; i,n:Word; fak,mean,sigm:Real;
 begin
 sum1:=0; sum2:=0;
 with ClustTab do
  begin
  x:=Xanf;
  for n:=1 to AnzIntv do
   begin
   f:=0; for i:=1 to Anz do with Dat[i] do
          begin
          fak:=M0*Xdel; mean:=Xanf+(M1-0.5)*Xdel; sigm:=(M2+1)*Xdel*GlFaktor;
          f:=f+fak*WdNvt(x,mean,sigm);
          end;
   err:=Histogr[n]-f;
   sum1:=sum1+err;
   sum2:=sum2+sqr(err);
   x:=x+Xdel;
   end;
  AnzClust:=Anz;
  Merr:=sum1/AnzIntv;
  Rmse:=sqrt(sum2/AnzIntv-sqr(Merr));
  end;
 end;


procedure DsplError(AnzClust:Word; Merr,Rmse:Real);
 Const x=400; y=10;
 Var anz:Integer;
 begin
 anz:=AnzClust;
 TextColor(ApproxColor);
 WriteXYG(x,y   ,'Anzahl Nvt-Modelle : '+StrI(anz,6));
 WriteXYG(x,y+10,'mittl. Abweichung  : '+StrR(Merr,6,2));
 WriteXYG(x,y+20,'Stand. Abweichung  : '+StrR(Rmse,6,2));
 end;


procedure WrClustLst(ClustLstSvDatei:PathStr; ClustTab:ClustTab_T; GrenzTab:GrenzTab_T);
 Var
  i:Word; f:text; t:String;
 begin
 Assign(f,ClustLstSvDatei); Rewrite(f);

 writeln(f,'Clustertabelle');
 writeln(f);
 writeln(f,'Histogramm : ',HistRdDatei);
 case HistType of
  0: t:='Eigen';
  1: t:='Fremd';
  2: t:='Beide';
 end;
 writeln(f,'Eigen/Fremd: ',t);
 writeln(f,'Selectlabel: ',SlctLabel);
 writeln(f,'Clusterschwelle fr die Teilung ......... : ',StrR(ClustSchw,7,3));
 writeln(f,'Wanderungsschwelle als Endekriterium .... : ',StrR(WndrgSchw,7,3));
 writeln(f);
 writeln(f);

 writeln(f,'Int  first   last breite    anz    ref  sigma');
 writeln(f,'---------------------------------------------');
           {123 123456 123456 123456 123456 123456 123456}

 for i:=1 to GrenzTab.Anz do
  begin
  writeln(f,i:3,
            GrenzTab.Dat[i]  .Ind                      :7,
            GrenzTab.Dat[i+1].Ind-1                    :7,
            GrenzTab.Dat[i+1].Ind-GrenzTab.Dat[i].Ind  :7,
            Clusttab.Dat[i]  .M0                       :7:0,
            Clusttab.Dat[i]  .M1                       :7:2,
            Clusttab.Dat[i]  .M2                       :7:2);
  end;
 Close(f);                     
 end;



procedure GetEigFrmHist(SlctLabel:Char);
 Var n,k,kk:Word; 
 begin
 if SlctLabel=#32 then k:=0
                  else begin
                       k:=1;
                       while not (ClsLst[k]=SlctLabel) do Inc(k);
                       end;
 for n:=1 to AnzIntv do
  begin
  if k=0 then begin
              Histeig[n]:=0; Histfrm[n]:=0;
              for kk:=1 to KlAnz do begin
                                    Histeig[n]:=Histeig[n]+Hist^[n,kk,1];
                                    Histfrm[n]:=Histfrm[n]+Hist^[n,kk,2];
                                    end;
              Histeig[n]:=Histeig[n]/KlAnz; Histfrm[n]:=Histfrm[n]/KlAnz;
              end
         else begin
              Histeig[n]:=Hist^[n,k,1];
              Histfrm[n]:=Hist^[n,k,2];
              end;
  end;
 end;


procedure MakeHistGlbw;
 Var n:Word; eig,frm,glbw:Real; 
 begin
 for n:=1 to AnzIntv do
  begin
  eig:=Histeig[n]; frm:=Histfrm[n];
  if eig+frm>0 then glbw:=eig/(eig+frm) else glbw:=0;
  Histglbw[n]:=glbw;
  end;
 end;


procedure PlotGlbwFromHistGlbw;
 Var v:Vector_2; n:Word; x:Real;
 begin
 SetColor(AktGlbwColor);
 l_art:=LMuster[GlbwLineStyle];
 x:=Xanf+0.5*XDel;
 SetV(x,FakGlbw*Histglbw[1],v); LMoveToV(v);
 x:=x+XDel;
 for n:=2 to AnzIntv do
  begin
  SetV(x,FakGlbw*Histglbw[n],v); LLineToV(v);
  x:=x+XDel;
  end;
 end;



procedure FiltHistAver(Par:Word; He:Hist_T; Var Ha:Hist_T);
 Var ne,na,nn:Integer; w:Real;
 begin
 for na:=1 to AnzIntv do
  begin
  w:=0;
  for ne:=na-Par to na+Par do
   if (ne>=1) and (ne<=AnzIntv) then w:=He[ne]+w;
  Ha[na]:=w/(2*Par+1);
  end;
 end;



procedure FiltHistGauss(Par:Word; He:Hist_T; Var Ha:Hist_T);
 Var ne,na,nn:Integer; w:Real; koeff:Array[0..18] of Real;
     Test:Boolean;
 begin

 w:=0; koeff[0]:=1;
 for nn:=1 to 2*Par do
  begin
  koeff[nn]:=Exp(-nn/Par);
  w:=w+koeff[nn];
  end;
 for nn:=0 to 2*Par do koeff[nn]:=koeff[nn]/(1+2*w);

 for na:=1 to AnzIntv do
  begin
  w:=0;
  for nn:=-2*Par to 2*Par do
   begin
   ne:=na+nn;
   if (ne>=1) and (ne<=AnzIntv) then w:=w+He[ne]*koeff[abs(nn)];
   end;
  Ha[na]:=w;
  end;
 end;



procedure FiltHistMedian(Par:Word; He:Hist_T; Var Ha:Hist_T);
 Var n,m,p:Integer;
     mm:Word;
     rang,rangzeiger:Array[1..19] of Word;
     wertneu,wertfilt:Real;
     rangweg,rangfilt,rangneu:Word;

 begin
 mm:=2*Par+1;
 for m:=1 to mm do rang[m]:=m;

 for n:=1 to AnzIntv do
  begin
  wertneu:=He[n]; rangweg:=rang[1]; rangneu:=1;
  for m:=2 to mm do
   begin
   p:=n-mm-1+m;
   if (p>=1) and (p<=AnzIntv) then wertfilt:=He[p] else wertfilt:=0;
   rangfilt:=rang[m];
   if rangfilt>rangweg then Dec(rangfilt);
   if wertneu<wertfilt then Inc(rangfilt) else Inc(rangneu);
   rang[m-1]:=rangfilt; rangzeiger[rangfilt]:=m-1;
   end;
   rang[mm]:=rangneu; rangzeiger[rangneu]:=mm;
   p:=n-Par;
  if (p>=1) and (p<=AnzIntv) then Ha[p]:=He[n-mm+rangzeiger[Par+1]];
  end;
 end;


procedure PlotGlbwModell;
 Var v:Vector_2; n:Word; x,y:Real;
 begin
 SetColor(AktGlbwColor);
 l_art:=LMuster[GlbwLineStyle];
 x:=Xanf+0.5*XDel;
 y:=GlbwMod(x);
 SetV(x,FakGlbw*GlbwMod(x),v); LMoveToV(v);
 x:=x+XDel;
 for n:=2 to AnzIntv do
  begin
  y:=GlbwMod(x);
  SetV(x,FakGlbw*GlbwMod(x),v); LLineToV(v);
  x:=x+XDel;
  end;
 end;


function SumHist(Hist:Hist_T):Real;
 Var n:Word; sum:Real;
 begin
 sum:=0;
 for n:=1 to AnzIntv do sum:=sum+Hist[n];
 SumHist:=sum;
 end;


function CheckMatchGlbwMod:Real;
 Var n:Word; x,y,err:Real;
 begin
 err:=0;
 x:=Xanf+0.5*XDel;
 for n:=1 to AnzIntv do
  begin
  y:=GlbwMod(x);
  err:=err+sqr(HistGlbw[n]-y)*(HistEig[n]+HistFrm[n]);
  x:=x+XDel;
  end;
 CheckMatchGlbwMod:=err/(SumEig+SumFrm);
 end;


procedure OptimGlbwMod;
 Var i,j,count:Word; parbest:ParGlbwMod_T; err,errbest:Real;
     improved:Boolean;

 function Rand(step:Real):Real;
  begin Rand:=step*(1-2*Random); end;

 begin
 parbest:=ParGlbwMod;
 errbest:=CheckMatchGlbwMod;
 count:=0;
 repeat
  improved:=False;
  for i:=1 to 50 do
   begin
   ParGlbwMod[1]:=parbest[1]+Rand(OptStepRand);
   ParGlbwMod[6]:=parbest[6]+Rand(OptStepRand);
   ParGlbwMod[3]:=MaxR(            0,MinR(            1,parbest[3]+Rand(OptStepRand)));
   ParGlbwMod[4]:=MaxR(ParGlbwMod[3],MinR(            1,parbest[4]+Rand(OptStepRand)));
   ParGlbwMod[2]:=MaxR(            0,MinR(ParGlbwMod[3],parbest[2]+0.5*Rand(OptStepRand)));
   ParGlbwMod[5]:=MaxR(ParGlbwMod[4],MinR(            1,parbest[5]+0.5*Rand(OptStepRand)));
   err:=CheckMatchGlbwMod;
   if err<errbest then begin
                       errbest:=err;                
                       parbest:=ParGlbwMod;
                       improved:=True;
                       end;
   end;
  if not improved then Inc(count);
  ParGlbwMod:=parbest;
  OptStepRand:=MaxR(OptStepRandMin,OptStepRand*SimFakRand);
  if PrtkOpt then
   begin
   WriteXYG(53,20,'Fehlerquadrat = '+StrR(errbest,7,5));
   WriteXYG(53,30,'Fehler        = '+StrR(Sqrt(errbest),7,5));
   WriteXYG(53,40,'OptStepRand   = '+StrR(OptStepRand,7,5));
   WriteXYG(53,50,'Count         = '+StrI(count,7));
   for i:=1 to 6 do WriteXYG(53,60+10*i,'ParVekt['+StrI(i,1)+']    = '+StrR(ParGlbwMod[i],11,8));
   end;
  if DsplOpt then PlotGlbwModell;
 until (((not improved) and (count=5)) or KeyPressed);
 end;



procedure GradVektFehlerFkt(Var GradVektFehler:ParGlbwMod_T);
 Var i,n:Word; x,y:Real; gradglbw:ParGlbwMod_T;
 begin
 for i:=1 to 6 do GradVektFehler[i]:=0;
 x:=Xanf+0.5*XDel;
 for n:=1 to AnzIntv do
  begin
  NablaGlbw(x,gradglbw);
  y:=GlbwMod(x);
  for i:=1 to 6 do
   begin
   GradVektFehler[i]:=GradVektFehler[i]
                      +(HistGlbw[n]-y)*(HistEig[n]+HistFrm[n])*gradglbw[i];
   end;
  x:=x+XDel;
  end;
 for i:=1 to 6 do GradVektFehler[i]:=-2*GradVektFehler[i]/(SumEig+SumFrm);
 end;




procedure OptimGlbwModGradAbstieg;
 Var i,j,jbest,count:Word;
     parbest,GradVekt,LastGradVekt,StepFak:ParGlbwMod_T;
     err,errbest,maxkompgrad:Real;
     ChckGrad:Boolean;

 begin
 for i:=1 to 6 do StepFak[i]:=OptStepGrad;
 errbest:=CheckMatchGlbwMod;
 count:=0;
 ChckGrad:=False;
 maxkompGrad:=1;
 repeat
  GradVektFehlerFkt(GradVekt);
  if ChckGrad then begin
                   maxkompgrad:=0;
                   for i:=1 to 6 do begin
                                    if Abs(GradVekt[i])>maxkompgrad
                                       then maxkompgrad:=Abs(GradVekt[i]);
                                    if Sign(LastGradVekt[i])=Sign(Gradvekt[i])
                                       then StepFak[i]:=MinR(2*StepFak[i],OptStepGradMax)
                                       else StepFak[i]:=OptStepGrad;
                                    end;
                   end
              else ChckGrad:=True;
  LastGradVekt:=GradVekt;
  for j:=1 to 30 do
   begin               
   for i:=1 to 6 do ParGlbwMod[i]:=ParGlbwMod[i]-StepFak[i]*GradVekt[i];
   ParGlbwMod[3]:=MaxR(            0,MinR(            1,ParGlbwMod[3]));
   ParGlbwMod[4]:=MaxR(ParGlbwMod[3],MinR(            1,ParGlbwMod[4]));
   ParGlbwMod[2]:=MaxR(            0,MinR(ParGlbwMod[3],ParGlbwMod[2]));
   ParGlbwMod[5]:=MaxR(ParGlbwMod[4],MinR(            1,ParGlbwMod[5]));  
   err:=CheckMatchGlbwMod;
   if err<=errbest then begin
                       jbest:=j;
                       errbest:=err;
                       parbest:=ParGlbwMod;
                       end;
   end;
  ParGlbwMod:=parbest;        
  OptStepGrad:=MaxR(OptStepGradMin,OptStepGrad*SimFakGrad);
  Inc(count);
  if PrtkOpt then
   begin 
   WriteXYG(53, 20,'Fehlerquadrat = '+StrR(err,7,5));
   WriteXYG(53, 30,'Fehler        = '+StrR(Sqrt(err),7,5));
   WriteXYG(53, 40,'OptStepGrad   = '+StrR(OptStepGrad,7,5));
   WriteXYG(53, 50,'MaxKompGrad   = '+StrR(MaxKompGrad,7,5));
   WriteXYG(53, 60,'Schritt       = '+StrI(jbest,7));
   WriteXYG(53, 70,'Count         = '+StrI(count,7));
   for i:=1 to 6 do WriteXYG(53, 80+10*i,'ParVekt['+StrI(i,1)+']    = '+StrR(ParGlbwMod[i],11,8));
   for i:=1 to 6 do WriteXYG(53,150+10*i,'GrdVekt['+StrI(i,1)+']    = '+StrR(GradVekt[i],11,8));
   for i:=1 to 6 do WriteXYG(53,220+10*i,'StepFak['+StrI(i,1)+']    = '+StrR(StepFak[i],11,4));
   end;
  if DsplOpt then PlotGlbwModell;
 until ((count=100) or (maxkompgrad<LimitGrad) or KeyPressed);
 end;



begin
end.