unit JS_MTR;


Interface

Uses
 dos,crt,js_sub,js_tio;

Type
 Vector_2 = array[1..2] of Real;
 Matrix_2 = array[1..2,1..2] of Real;
 Vector_6 = array[1..6] of Real;
 Matrix_6 = array[1..6,1..6] of Real;

Const
 einhvx: Vector_2 = (1,0);
 einhvy: Vector_2 = (0,1);


procedure SetV(v1,v2:Real;VAR v:Vector_2);
procedure AddVV(v1:Vector_2; v2:Vector_2; VAR r:Vector_2);
procedure SubVV(v1:Vector_2; v2:Vector_2; VAR r:Vector_2);
procedure MulSV(s:Real; v:Vector_2; VAR r:Vector_2);
function  SkPVV(v1:Vector_2; v2:Vector_2):Real;
function  BetrqV(v:Vector_2):Real;
function  AbstqVV(v1:Vector_2; v2:Vector_2):Real;
function  SkPVV6(v1:Vector_6; v2:Vector_6):Real;

procedure SetM(m11,m12,m21,m22:Real; VAR m:Matrix_2);
procedure AddMM(m1:Matrix_2; m2:Matrix_2; VAR r:Matrix_2);
procedure SubMM(m1:Matrix_2; m2:Matrix_2; VAR r:Matrix_2);
procedure MulSM(s:Real; m:Matrix_2; VAR r:Matrix_2);
procedure MulMV(m:Matrix_2; v:Vector_2; VAR r:Vector_2);
procedure MulMM(m1:Matrix_2; m2:Matrix_2; VAR r:Matrix_2);
procedure TrpM(m:Matrix_2; Var r:Matrix_2);
procedure DyaVV(v:Vector_2; VAR m:Matrix_2);

function  BetrqM(m:Matrix_2):Real;
function  DetM(m:Matrix_2):Real;
function  QuaF(m:Matrix_2; v:Vector_2):Real;
function  QuaF6(m:Matrix_6; v:Vector_6):Real;
procedure InvM(m:Matrix_2; VAR r:Matrix_2);

procedure RotM(alpha:Real; VAR m:Matrix_2);
procedure PlKV(v:Vector_2; VAR r:Real; VAR phi:Real);
procedure AlpB(b:Matrix_2; VAR alpha:Real); VAR v:Vector_2; phi,r:Real;
procedure DiaM(d1,d2:Real; VAR m:Matrix_2);
procedure EigMs(m:Matrix_2; Var d,b:Matrix_2);
procedure SqrtMd(d:Matrix_2; VAR r:Matrix_2);

procedure VqPV(v:Vector_2; VAR x:Vector_6);

procedure DispM(z,s:Integer; m:Matrix_2);
procedure DispMG(x,y:Integer; m:Matrix_2);


Implementation

procedure SetV(v1,v2:Real;VAR v:Vector_2);
 begin v[1]:=v1; v[2]:=v2; end;

procedure AddVV(v1:Vector_2; v2:Vector_2; VAR r:Vector_2);
 begin r[1]:=v1[1]+v2[1]; r[2]:=v1[2]+v2[2]; end;

procedure SubVV(v1:Vector_2; v2:Vector_2; VAR r:Vector_2);
 begin r[1]:=v1[1]-v2[1]; r[2]:=v1[2]-v2[2]; end;

procedure MulSV(s:Real; v:Vector_2; VAR r:Vector_2);
 begin r[1]:=s*v[1]; r[2]:=s*v[2]; end;

function SkPVV(v1:Vector_2; v2:Vector_2):Real;
 begin SkPVV:=v1[1]*v2[1]+v1[2]*v2[2]; end;

function BetrqV(v:Vector_2):Real;
 begin BetrqV:=sqr(v[1])+sqr(v[2]); end;

function AbstqVV(v1:Vector_2; v2:Vector_2):Real;
 begin AbstqVV:=sqr(v1[1]-v2[1])+sqr(v1[2]-v2[2]); end;

function SkPVV6(v1:Vector_6; v2:Vector_6):Real;
 Var n:Word; res:Real;
 begin
 res:=0;
 for n:=1 to 6 do res:=res+v1[n]*v2[n];
 SkPVV6:=res;
 end;


procedure SetM(m11,m12,m21,m22:Real; VAR m:Matrix_2);
 begin
 m[1,1]:=m11;  m[1,2]:=m12;
 m[2,1]:=m21;  m[2,2]:=m22;
 end;

procedure AddMM(m1:Matrix_2; m2:Matrix_2; VAR r:Matrix_2);
 begin
 r[1,1]:=m1[1,1]+m2[1,1];
 r[1,2]:=m1[1,2]+m2[1,2];
 r[2,1]:=m1[2,1]+m2[2,1];
 r[2,2]:=m1[2,2]+m2[2,2];
 end;

procedure SubMM(m1:Matrix_2; m2:Matrix_2; VAR r:Matrix_2);
 begin
 r[1,1]:=m1[1,1]-m2[1,1];
 r[1,2]:=m1[1,2]-m2[1,2];
 r[2,1]:=m1[2,1]-m2[2,1];
 r[2,2]:=m1[2,2]-m2[2,2];
 end;

procedure MulSM(s:Real; m:Matrix_2; VAR r:Matrix_2);
 begin
 r[1,1]:=s*m[1,1]; r[1,2]:=s*m[1,2];
 r[2,1]:=s*m[2,1]; r[2,2]:=s*m[2,2];
 end;

procedure MulMV(m:Matrix_2; v:Vector_2; VAR r:Vector_2);
 begin
 r[1]:=m[1,1]*v[1]+m[1,2]*v[2];
 r[2]:=m[2,1]*v[1]+m[2,2]*v[2];
 end;

procedure MulMM(m1:Matrix_2; m2:Matrix_2; VAR r:Matrix_2);
 begin
 r[1,1]:=m1[1,1]*m2[1,1]+m1[1,2]*m2[2,1];
 r[1,2]:=m1[1,1]*m2[1,2]+m1[1,2]*m2[2,2];
 r[2,1]:=m1[2,1]*m2[1,1]+m1[2,2]*m2[2,1];
 r[2,2]:=m1[2,1]*m2[1,2]+m1[2,2]*m2[2,2];
 end;

procedure TrpM(m:Matrix_2; Var r:Matrix_2);
 begin
 r[1,1]:=m[1,1]; r[1,2]:=m[2,1];
 r[2,1]:=m[1,2]; r[2,2]:=m[2,2];
 end;

procedure DyaVV(v:Vector_2; VAR m:Matrix_2);
 begin
 m[1,1]:=Sqr(v[1]); m[1,2]:=v[1]*v[2];
 m[2,1]:=m[1,2];    m[2,2]:=Sqr(v[2]);
 end;

function BetrqM(m:Matrix_2):Real;
 begin BetrqM:=sqr(m[1,1])+sqr(m[1,2])+sqr(m[2,1])+sqr(m[2,2]); end;
  
function DetM(m:Matrix_2):Real;
 begin
 DETM:=m[1,1]*m[2,2]-m[2,1]*m[1,2];
 end;

function QuaF(m:Matrix_2; v:Vector_2):Real;
 begin
 QUAF:=m[1,1]*Sqr(v[1]) + 2*m[1,2]*v[1]*v[2] + m[2,2]*Sqr(v[2]);
 end;

function QuaF6(m:Matrix_6; v:Vector_6):Real;
 Var i,j:Word; res:Real;
 begin
 res:=0;
 for i:=1 to 6 do
  for j:=1 to 6 do
   res:=res+v[i]*m[i,j]*v[j];
 QUAF6:=res;
 end;

procedure InvM(m:Matrix_2; VAR r:Matrix_2);
 Var detinv:Real;
 begin
 detinv:=1/DetM(m);
 r[1,1]:= detinv*m[2,2]; r[1,2]:=-detinv*m[1,2];
 r[2,1]:=-detinv*m[2,1]; r[2,2]:= detinv*m[1,1];
 end;

procedure RotM(alpha:Real; VAR m:Matrix_2);
 VAR bog:Real;
 begin
 bog:=PI/180*alpha;
 m[1,1]:= cos(bog); m[1,2]:=-sin(bog);
 m[2,1]:= sin(bog); m[2,2]:= cos(bog);
 end;

procedure PlKV(v:Vector_2; VAR r:Real; VAR phi:Real);
 VAR x,y:Real;
 begin
 x:=v[1]; y:=v[2];
 if (x=0) and (y=0) then begin phi:=0; r:=0; end
 else
  begin
  if  Abs(x) >= Abs(y) then
   begin
   phi:=ArcTan(y/x);
   if x<0 then phi:=phi+PI
   else if y<0 then phi:=phi+2*PI;
   end
  else
   begin
   phi:=0.5*PI-ArcTan(x/y);
   if y<0 then phi:=phi+PI;
   end;
  r:=Sqrt(Sqr(x)+Sqr(y));
  end;
 end;

procedure AlpB(b:Matrix_2; VAR alpha:Real); VAR v:Vector_2; phi,r:Real;
 begin
 SETV(b[1,1],b[2,1],v);
 PLKV(v,r,phi);
 alpha:=180/PI*phi;
 end;

procedure DiaM(d1,d2:Real; VAR m:Matrix_2);
 begin
 m[1,1]:=d1; m[1,2]:= 0;
 m[2,1]:= 0; m[2,2]:=d2;
 end;

procedure EigMs(m:Matrix_2; Var d,b:Matrix_2);
 Var sum1,sum2,ew1,ew2,r1,r2,norm:Real;
 begin
 sum1:=(m[1,1]+m[2,2])/2;
 sum2:=Sqrt(Sqr((m[1,1]-m[2,2])/2)+Sqr(m[1,2]));
 ew1:=sum1+sum2;
 ew2:=sum1-sum2;
 r1:=m[1,2];
 r2:=ew1-m[1,1];
 norm:=Sqrt(Sqr(r1)+Sqr(r2));
 b[1,1]:=r1/norm;
 b[2,1]:=r2/norm;
 b[1,2]:=-b[2,1];
 b[2,2]:= b[1,1];
 d[1,1]:=ew1; d[1,2]:=0;
 d[2,1]:=0;   d[2,2]:=ew2;
 end;

procedure SqrtMd(d:Matrix_2; VAR r:Matrix_2);
 begin
 r[1,1]:=Sqrt(d[1,1]); r[1,2]:=0;
 r[2,1]:=0;            r[2,2]:=Sqrt(d[2,2]);
 end;

procedure VqPV(v:Vector_2; VAR x:Vector_6);
 begin
 x[1]:=1;
 x[2]:=v[1];
 x[3]:=v[2];
 x[4]:=v[1]*v[1];
 x[5]:=v[1]*v[2];;
 x[6]:=v[2]*v[2];;
 end;

procedure DispM(z,s:Integer; m:Matrix_2);
 begin
 gotoxy(s,z);   write(m[1,1]:8:2,m[1,2]:8:2);
 gotoxy(s,z+1); write(m[2,1]:8:2,m[2,2]:8:2);
 end;

procedure DispMG(x,y:Integer; m:Matrix_2);
 begin
 writeXYG(x,y,StrR(m[1,1],8,2)+StrR(m[1,2],8,2));
 writeXYG(x,y+ChrHght,StrR(m[2,1],8,2)+StrR(m[2,2],8,2));
 end;


begin
end.