unit JS_PKX;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_koor,js_stm,js_mtr,js_gra,js_mat;


Const
 AnzIntv=100;
 XAnf   =-2.0;
 XEnd   =+3.0;
 XDel   =(XEnd-XAnf)/AnzIntv;
 Fak    =1/XDel;

Type
 ProConLstRec_T = record
                   class: Char;
                   cmpcl: Char;
                  end;
 ProConLst_T    = record
                   anz: Word;
                   dat: array [1..AnzElemMod] of ProConLstRec_T;
                  end;

 ProConFrmHist_P   = ^ProConFrmHist_T;
 ProConFrmHist_T   = array [0..AnzIntv+1,1..AnzElemMod,1..3] of Word;
 ProConFrmModRec_T = record
                      anzpro:  Word;
                      meanpro: Real;
                      sigmpro: Real;
                      anzcon:  Word;
                      meancon: Real;
                      sigmcon: Real;
                      anzfrm:  Word;
                      meanfrm: Real;
                      sigmfrm: Real;
                     end;
 ProConFrmMod_T    = record
                      anz: Word;
                      dat: array [1..AnzElemMod] of ProConFrmModRec_T;
                     end;

Var
 HistPfad,             HistRdDatei, HistSvDatei: PathStr;


 ProHistColor:       Word;
 ProHistLineStyle:   Word;
 ConHistColor:       Word;
 ConHistLineStyle:   Word;
 FrmHistColor:       Word;
 FrmHistLineStyle:   Word;
 GlaubwColor:        Word;
 GlaubwLineStyle:    Word;
 GlaubwSColor:       Word;
 GlaubwSLineStyle:   Word;
 GlaubwFaktor:       Real;
 KlAnz:              Word;
 AnzSmpl:            Word;
 DVkt:               DVkt_T;
 Hist:               ProConFrmHist_P;
 ClsLst:             ClsLst_T;
 ProConLst:          ProConLst_T;
 HistType:           Byte;
 Slct:               Byte;
 HistFertig:         Boolean;
 ProConFrmMod:       ProConFrmMod_T;
 ProConFrmModFertig: Boolean;
 KlfGeladen:         Boolean;
 FktStchp:           Word;


procedure PfadeInitPKX(PfadeMaske: MskPar_T);
procedure ColorInitPKX(FarbeMaske:MskPar_T);

function  FachNr(x:Real):Word;
procedure ClrProConFrmHist;
procedure SaveProConFrmHist(HistSvDatei:PathStr; OK:Boolean);
procedure LoadProConFrmHist(HistRdDatei:PathStr; OK:Boolean);
procedure ProConFrmHistogramm(StchpRdDatei:PathStr; OK:Boolean);
procedure PlotProConFrmHist(Slct:Byte; HistType:Byte);

procedure ClrProConFrmMod;
procedure AkkumProConFrmMod(d:Real; m:Word; i:Word);
procedure CmpltProConFrmMod;
procedure ProConFrmModFromHist;
procedure ProConFrmModFromMom(RzpDat:RzpDat_T; MomPfad:PathStr; KlfDat:KlfDat_T; OK:Boolean);
procedure PlotNvt(Slct:Byte; HistType:Byte);
procedure PlotGlbw(Slct:Byte);
procedure PlotGlbwFromQMS(Slct:Byte);

procedure ClrProConLst;
procedure ProConLstFromKlfDat(KlfDat:KlfDat_T; Var ProConLst:ProConLst_T);
procedure ClSlctFromProConLst(ProConLst:ProConLst_T; Var Klanz:Word; Var ClSlct:SetChar_T);

procedure KmplKlfPKL(Var KlfDat:KlfDat_T);



Implementation

procedure PfadeInitPKX(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=   PfadeMaske.erg[ 1];
 KoorRdDflt:= PfadeMaske.erg[ 2];
 FarbePfad:=  PfadeMaske.erg[ 3];
 FarbeRdDflt:=PfadeMaske.erg[ 4];
 HistPfad:=   PfadeMaske.erg[ 5];
 KlfPfad:=    PfadeMaske.erg[ 6];
 StchpPfad:=  PfadeMaske.erg[ 7];
 RzpPfad:=    PfadeMaske.erg[ 8];
 MomPfad:=    PfadeMaske.erg[ 9];
 EditorPfad:= PfadeMaske.erg[10];

 KoorRdDatei:= KoorRdDflt;
 FarbeRdDatei:=FarbeRdDflt;
 end;

procedure ColorInitPKX(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 ProHistColor:=      ColorFromStr(FarbeMaske.erg[4]);
 ProHistLineStyle:=  ValI(Trim(FarbeMaske.erg[5]));
 ConHistColor:=      ColorFromStr(FarbeMaske.erg[6]);
 ConHistLineStyle:=  ValI(Trim(FarbeMaske.erg[7]));
 FrmHistColor:=      ColorFromStr(FarbeMaske.erg[8]);
 FrmHistLineStyle:=  ValI(Trim(FarbeMaske.erg[9]));
 GlaubwColor:=       ColorFromStr(FarbeMaske.erg[10]);
 GlaubwLineStyle:=   ValI(Trim(FarbeMaske.erg[11]));
 GlaubwSColor:=      ColorFromStr(FarbeMaske.erg[12]);
 GlaubwSLineStyle:=  ValI(Trim(FarbeMaske.erg[13]));
 GlaubwFaktor:=      ValR(Trim(FarbeMaske.erg[14]));
 FktStchp:=          ValI(Trim(FarbeMaske.erg[15]));
 end;

function  FachNr(x:Real):Word;
 begin
 FachNr:=MAXI(MinI(Trunc((x-XAnf)*Fak)+1,AnzIntv+1),0);
 end;

procedure ClrProConFrmHist;
 Var n,m,i:Word;
 begin
 for n:=0 to AnzIntv+1 do
  for m:=1 to AnzElemMod do for i:=1 to 3 do Hist^[n,m,i]:=0;
 end;


procedure SaveProConFrmHist(HistSvDatei:PathStr; OK:Boolean);
 Var f:text; n,m:Word; UntFachGrenze:Real;
 begin
 Assign(f,HistSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then
  begin
  writeln(f,'* Pro/Contra/Fremd-Histogramm');
  writeln(f,'* ---------------------------');
  writeln(f,'* Klassifikator ..........: '+KlfRdDatei);
  writeln(f,'* Merkmals-Vektoren aus ..: '+StchpRdDatei);
  writeln(f,'* Anzahl = '+StrI(AnzSmpl,0));
  writeln(f,'* --------------------------------------------');
  write(f,'* Pro/Con-Label =  ');
  with ProConLst do
   begin
   for m:=1 to anz do write(f,FillStr(dat[m].class+'/'+dat[m].cmpcl,18));
   writeln(f);
   write(f,'*  unt.Gr.');
   for m:=1 to anz do write(f,'   pro   con fremd');
   writeln(f);
   UntFachGrenze:=XAnf;
   for n:=0 to AnzIntv+1 do
    begin
    if n=0 then write(f,-9.999:10:3)
           else begin
                write(f,UntFachGrenze:10:3);
                UntFachGrenze:=UntFachGrenze+XDel;
                end;
    for m:=1 to anz do write(f,hist^[n,m,1]:6,
                               hist^[n,m,2]:6,
                               hist^[n,m,3]:6);
    writeln(f);
    end;
   end;
  Close(f);
  end;
 end;

procedure LoadProConFrmHist(HistRdDatei:PathStr; OK:Boolean);
 Var f:text; n,m,mm:Word; s,cs:String; DataFound:Boolean; dummy:Real;
 begin
 Assign(f,HistRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if Ok then
  begin
  n:=0; DataFound:=False;
  repeat
   readln(f,s);
   if s[1]='*' then
    begin
    GetPar(s);
    if ParStr(2)='Anzahl'        then AnzSmpl:=ValI(ParStr(4));
    if ParStr(2)='Pro/Con-Label' then begin
                                      with ProConLst do
                                       begin
                                       for m:=4 to ParCount do
                                        begin
                                        cs:=ParStr(m);
                                        dat[m-3].class:=cs[1];
                                        dat[m-3].cmpcl:=cs[3];
                                        end;
                                       mm:=ParCount-3;
                                       anz:=mm;
                                       end;
                                      end;
    if ParStr(2)='unt.Gr.'       then DataFound:=True;
    end;
  until DataFound;
  repeat
   read(f,dummy);
   for m:=1 to mm do read(f,hist^[n,m,1],
                            hist^[n,m,2],
                            hist^[n,m,3]);
   readln(f);
   Inc(n);
  until Eof(f);
  Close(f);
  end;
 end;


procedure ProConFrmHistogramm(StchpRdDatei:PathStr; OK:Boolean);
 Type
  PKLResRec_T = record
                 class: Char;
                 cmpcl: Char;
                 d:     Real;
                end;
  PKLRes_T    = record
                 anz: Word;
                 dat: array [1..AnzElemMod] of PKLResRec_T;
                end;
 Var
  f:Text; m,n,i:Word; d:Real;
  PKLRes:PKLRes_T;

 procedure GetPKLResult;
  Var v:Vector_2; xv:Vector_6; d:Real; m,i:Word;
  begin
  ReadLn(f,SmplClass,SmplNr,v[1],v[2]);
  with KlfDat do
   begin
   VqPV(v,xv);
   if (typ='PKL') or (typ='PKX') then
    {Klassifikatornetz: PKL, kann bestehen aus NVK, QMS}
    {                   PKX, besteht aus QMF           }
    begin
    for m:=1 to anz do with dat[m] do
     begin
     d:=0; for i:=1 to 6 do d:=d+koeff[i]*xv[i];
     if eqtyp='NVK' then d:=exp(MaxR(-70,d));
     PKLRes.dat[m].class:=class;
     PKLRes.dat[m].cmpcl:=cmpcl;
     PKLRes.dat[m].d:=d;
     end;
    PKLRes.anz:=anz;
    end;
   end;
  end;


 begin
 Assign(f,StchpRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if OK then
  begin
  ClrProConFrmHist; ClrProConFrmMod; AnzSmpl:=0;
  repeat
   GetPKLResult;
   if (SmplClass in ClSlct) then
     begin
     for m:=1 to PKLRes.anz do
      begin
      d:=PKLRes.dat[m].d;
      n:=FachNr(d);
      if SmplClass=PKLRes.dat[m].class       then i:=1
       else if SmplClass=PKLRes.dat[m].cmpcl then i:=2
       else                                       i:=3;
      Inc(hist^[n,m,i]);
      AkkumProConFrmMod(d,m,i);
      end;
     Inc(AnzSmpl);
     end;
  until Eof(f);
  Close(f);
  CmpltProConFrmMod;
  ProConFrmModFertig:=True;
  end;
 end;

procedure PlotProConFrmHist(Slct:Byte; HistType:Byte);
 Var v:Vector_2; m,n,anz:Word; x,h:Real; eps:Real;
 begin
 x:=Xanf+0.5*XDel; eps:=0.2*XDel;
 anz:=ProConLst.anz;
 for n:=1 to AnzIntv do
  begin
  if HistType in [0,3,4] then begin
                              SetColor(ProHistColor);
                              l_art:=LMuster[ProHistLineStyle];
                              SetV(x+eps,0,v); LMoveToV(v);
                              if Slct=0 then begin
                                             h:=0;
                                             for m:=1 to anz do h:=h+Hist^[n,m,1];
                                             h:=h/anz;
                                             end
                                        else h:=Hist^[n,Slct,1];
                              SetV(x+eps,h,v); LLineToV(v);
                              end;
  if HistType in [1,3,4] then begin
                              SetColor(ConHistColor);
                              l_art:=LMuster[ConHistLineStyle];
                              SetV(x-eps,0,v); LMoveToV(v);
                              if Slct=0 then begin
                                             h:=0;
                                             for m:=1 to anz do h:=h+Hist^[n,m,2];
                                             h:=h/anz;
                                             end
                                        else h:=Hist^[n,Slct,2];
                              SetV(x-eps,h,v); LLineToV(v);
                              end;
  if HistType in [2,4]   then begin
                              SetColor(FrmHistColor);
                              l_art:=LMuster[FrmHistLineStyle];
                              SetV(x,0,v); LMoveToV(v);
                              if Slct=0 then begin
                                             h:=0;
                                             for m:=1 to anz do h:=h+Hist^[n,m,3];
                                             h:=h/anz;
                                             end
                                        else h:=Hist^[n,Slct,3];
                              SetV(x,h,v); LLineToV(v);
                              end;
  x:=x+XDel;
  end;
 end;


procedure ClrProConFrmMod;
 Var m:Word;
 begin
 with ProConFrmMod do
  for m:=1 to AnzElemMod do with dat[m] do
   begin
   anzpro:= 0; meanpro:=0; sigmpro:=0;
   anzcon:= 0; meancon:=0; sigmcon:=0;
   anzfrm:= 0; meanfrm:=0; sigmfrm:=0;
   end;
 end;


procedure AkkumProConFrmMod(d:Real; m:Word; i:Word);
 begin
 with ProConFrmMod.dat[m] do
   case i of
    1: begin Inc(anzpro); meanpro:=meanpro+d; sigmpro:=sigmpro+sqr(d); end;
    2: begin Inc(anzcon); meancon:=meancon+d; sigmcon:=sigmcon+sqr(d); end;
    3: begin Inc(anzfrm); meanfrm:=meanfrm+d; sigmfrm:=sigmfrm+sqr(d); end;
   end;
 end;


procedure CmpltProConFrmMod;
 var m:Word;
 begin
 ProConFrmMod.anz:=ProConLst.anz;
 with ProConFrmMod do
  for m:=1 to anz do with dat[m] do
   begin
   meanpro:=meanpro/anzpro; sigmpro:=Sqrt(sigmpro/anzpro-Sqr(meanpro));
   meancon:=meancon/anzcon; sigmcon:=Sqrt(sigmcon/anzcon-Sqr(meancon));
   meanfrm:=meanfrm/anzfrm; sigmfrm:=Sqrt(sigmfrm/anzfrm-Sqr(meanfrm));
   end;
 end;


procedure ProConFrmModFromHist;
 Var m,n:Word;
     sumpro,sumcon,sumfrm,hpro,hcon,hfrm:Word;
     x,sumprox,sumproxx,sumconx,sumconxx,sumfrmx,sumfrmxx:Real;
 begin
 with ProConFrmMod do
  begin
  anz:=ProConLst.anz;
  for m:=1 to anz do
   begin
   sumpro:=  0; sumprox:= 0; sumproxx:=0;
   sumcon:=  0; sumconx:= 0; sumconxx:=0;
   sumfrm:=  0; sumfrmx:= 0; sumfrmxx:=0;
   x:=Xanf-0.5*Xdel;
   for n:=0 to AnzIntv+1 do begin
                            x:=x+XDel; hpro:=Hist^[n,m,1];
                                       hcon:=Hist^[n,m,2];
                                       hfrm:=Hist^[n,m,3];
                            sumpro:=  sumpro+  hpro;
                            sumprox:= sumprox+ hpro*x;
                            sumproxx:=sumproxx+hpro*Sqr(x);
                            sumcon:=  sumcon+  hcon;
                            sumconx:= sumconx+ hcon*x;
                            sumconxx:=sumconxx+hcon*Sqr(x);
                            sumfrm:=  sumfrm+  hfrm;
                            sumfrmx:= sumfrmx+ hfrm*x;
                            sumfrmxx:=sumfrmxx+hfrm*Sqr(x);
                            end;
   with dat[m] do
    begin
    anzpro:= sumpro;
    meanpro:=sumprox/sumpro;
    sigmpro:=Sqrt(sumproxx/sumpro-Sqr(meanpro));
    anzcon:= sumcon;
    meancon:=sumconx/sumcon;
    sigmcon:=Sqrt(sumconxx/sumcon-Sqr(meancon));
    anzfrm:= sumfrm;
    meanfrm:=sumfrmx/sumfrm;
    sigmfrm:=Sqrt(sumfrmxx/sumfrm-Sqr(meanfrm));
    end;
   end;
  end;
 end;


procedure ProConFrmModFromMom(RzpDat:RzpDat_T; MomPfad:PathStr; KlfDat:KlfDat_T; OK:Boolean);

 Var di:DirStr; na:NameStr; ex:ExtStr;
     Mom:MomRec_T;
     Cl:ClsLst_T;
     k,ks,zgr,nsc,kpro,kcon,kk,n,m:Word;
     Klf:KlfDat_T;
     mxpro,mxcon,mxfrm,a:Vector_6;
     mmpro,mmcon,mmfrm:Matrix_6;
     cppro,cpcon,fak:Real;

 procedure AddMomMat(c:Real; k:Word; Mom:MomRec_T);
  Var i,j:Word;
  begin
  with MomDat^.dat[k] do
   for i:=1 to 6 do
    for j:=1 to 6 do
     matrx[i,j]:=matrx[i,j]+c*Mom.matrx[i,j];
  end;

 function Findcls(cls:Char):Word;
  Var k:Word;
  begin
  k:=1; while (cl[k]<>cls) and (k<=MomDat^.anz) do Inc(k);
  if k>MomDat^.anz then k:=0;
  Findcls:=k;
  end;

 begin
 FSplit(MomPfad,di,na,ex);
 ClearMom;
 with RzpDat do
  begin
  for k:=1 to anzcl do
   begin
   zgr:=  dat[k].zeigr;
   nsc:=  dat[k].anzsc;
   Cl[k]:=dat[zgr].class;
   for ks:=zgr to zgr+nsc-1 do with dat[ks] do
    begin
    LoadMom(di+name,Mom,OK);
    if OK then begin
               AddMomMat(scprb,k,Mom);
               AddMomMat(cprob*scprb,anzcl+1,Mom);
               end;
    end;
   MomDat^.dat[k].class:=dat[zgr].class;
   MomDat^.dat[k].count:=0;
   MomDat^.dat[k].aprio:=dat[zgr].cprob;
   end;
  MomDat^.anz:=anzcl;
  MomDat^.dat[anzcl+1].class:=' ';
  MomDat^.dat[anzcl+1].count:=0;
  MomDat^.dat[anzcl+1].aprio:=1.0;
  end;

  with KlfDat do
   begin
   for k:=1 to anz do
    begin
    for n:=1 to 6 do a[n]:= dat[k].koeff[n];
    kpro:=FindCls(dat[k].class);
    kcon:=FindCls(dat[k].cmpcl);

    for n:=1 to 6 do mxpro[n]:=MomDat^.dat[kpro].matrx[n,1];
    mmpro:=MomDat^.dat[kpro].matrx;

    for n:=1 to 6 do mxcon[n]:=MomDat^.dat[kcon].matrx[n,1];
    mmcon:=MomDat^.dat[kcon].matrx;

    cppro:=MomDat^.dat[kpro].aprio;
    cpcon:=MomDat^.dat[kcon].aprio;
    fak:=1/(1-cppro-cpcon);
    for n:=1 to 6 do
     begin
     for m:=1 to 6 do mmfrm[n,m]:=fak*MomDat^.dat[MomDat^.anz+1].matrx[n,m]
                                  -cppro*fak*MomDat^.dat[kpro].matrx[n,m]
                                  -cpcon*fak*MomDat^.dat[kcon].matrx[n,m];
     mxfrm[n]:=mmfrm[n,1];
     end;

    with ProConFrmMod.dat[k] do
     begin
     anzpro:=Round(FktStchp*cppro);
     meanpro:=SkpVV6(mxpro,a);
     sigmpro:=Sqrt(QuaF6(mmpro,a)-Sqr(meanpro));
     anzcon:=Round(FktStchp*cpcon);
     meancon:=SkpVV6(mxcon,a);
     sigmcon:=Sqrt(QuaF6(mmcon,a)-Sqr(meancon));
     anzfrm:=Round(FktStchp*(1-cppro-cpcon));
     meanfrm:=SkpVV6(mxfrm,a);
     sigmfrm:=Sqrt(QuaF6(mmfrm,a)-Sqr(meanfrm));
     end;
    end;
   end;
 end;



procedure PlotNvt(Slct:Byte; HistType:Byte);
 Var x,f:Real; fak:Real;
 begin
 if Slct>0 then with ProConFrmMod.dat[Slct] do
  begin
  if HistType in [0,3,4] then begin
                              fak:=anzpro*Xdel;
                              SetColor(ProHistColor);
                              l_art:=LMuster[ProHistLineStyle];
                              x:=Xanf;
                              f:=fak*WdNvt(x,meanpro,sigmpro);
                              SetV(x,f,v); LMoveToV(v);
                              repeat
                               x:=x+Xdel;
                               f:=fak*WdNvt(x,meanpro,sigmpro);
                               SetV(x,f,v); LLineToV(v);
                              until x>Xend;
                              end;
  if HistType in [1,3,4] then begin
                              fak:=anzcon*Xdel;
                              SetColor(ConHistColor);
                              l_art:=LMuster[ConHistLineStyle];
                              x:=Xanf;
                              f:=fak*WdNvt(x,meancon,sigmcon);
                              SetV(x,f,v); LMoveToV(v);
                              repeat
                               x:=x+Xdel;
                               f:=fak*WdNvt(x,meancon,sigmcon);
                               SetV(x,f,v); LLineToV(v);
                              until x>Xend;
                              end;
  if HistType in [2,4]   then begin
                              fak:=anzfrm*Xdel;
                              SetColor(FrmHistColor);
                              l_art:=LMuster[FrmHistLineStyle];
                              x:=Xanf;
                              f:=fak*WdNvt(x,meanfrm,sigmfrm);
                              SetV(x,f,v); LMoveToV(v);
                              repeat
                               x:=x+Xdel;
                               f:=fak*WdNvt(x,meanfrm,sigmfrm);
                               SetV(x,f,v); LLineToV(v);
                              until x>Xend;
                              end;
  end;
 end;

procedure PlotGlbw(Slct:Byte);
 Var x,f:Real; 
 begin
 if Slct>0 then with ProConFrmMod.dat[Slct] do
  begin
  SetColor(GlaubwColor);
  l_art:=LMuster[GlaubwLineStyle];
  x:=Xanf;
  f:=Glaubwfaktor*Glaubw(x,2,meanpro,sigmpro,meancon,sigmcon);
  SetV(x,f,v); LMoveToV(v);
  repeat
   x:=x+Xdel;
   f:=Glaubwfaktor*Glaubw(x,2,meanpro,sigmpro,meancon,sigmcon);
   SetV(x,f,v); LLineToV(v);
  until x>Xend;
  end;
 end;


procedure PlotGlbwFromQMS(Slct:Byte);
 Var x,f,s:Real;
 begin
 if Slct>0 then with KlfDat.dat[Slct] do
  begin
  s:=koeff[7];
  SetColor(GlaubwSColor);
  l_art:=LMuster[GlaubwSLineStyle];
  x:=Xanf;
  f:=Glaubwfaktor*GlaubwS(x,s);
  SetV(x,f,v); LMoveToV(v);
  repeat
   x:=x+Xdel;
   f:=Glaubwfaktor*GlaubwS(x,s);
   SetV(x,f,v); LLineToV(v);
  until x>Xend;
  end;
 end;


procedure ClrProConLst;
 Var m:Word;
 begin
 with ProConLst do
  begin
  anz:=0;
  for m:=1 to AnzElemMod do begin
                            dat[m].class:=' ';
                            dat[m].cmpcl:=' ';
                            end;
  end;
 end;


procedure ProConLstFromKlfDat(KlfDat:KlfDat_T; Var ProConLst:ProConLst_T);
 Var m:Word;
 begin
 with KlfDat do
  if (typ='PKL') or (typ='PKX') then
   begin
   for m:=1 to anz do with dat[m] do
    begin
    ProConLst.dat[m].class:=class;
    ProConLst.dat[m].cmpcl:=cmpcl;
    end;
   ProConLst.anz:=anz;
   end;
 end;


procedure ClSlctFromProConLst(ProConLst:ProConLst_T; Var Klanz:Word; Var ClSlct:SetChar_T);
 Var m,k,kanz:Word; ClsLst:Clslst_T;

 procedure Check(ch:Char);
  Var k:Word; found:Boolean;
  begin
  k:=1; found:=False;
  while not (found or (k>kanz)) do
   begin found:=(ClsLst[k]=ch); Inc(k); end;
  if not found then begin Inc(kanz); ClsLst[kanz]:=ch; end;
  end;

 begin
 with ProConLst do
  begin
  kanz:=0;
  for m:=1 to anz do
   begin
   Check(dat[m].class);
   Check(dat[m].cmpcl);
   end;
  KlAnz:=kanz;
  end;
 ClSlct:=[]; for k:=1 to KlAnz do ClSlct:=ClSlct+[ClsLst[k]];
 end;


procedure KmplKlfPKL(Var KlfDat:KlfDat_T);
 Var m,j:Word;
 begin
 with KlfDat do
  if ((typ='PKL') or (typ='PKX')) and (anz=ProConFrmMod.anz) then
    begin
    typ:='PKX';
    for m:=1 to anz do with dat[m] do with ProConFrmMod.dat[m] do
     begin
     eqtyp:='QMF';
     koeff[ 9]:=meanfrm;
     koeff[10]:=sigmfrm;
     end;
    end;
 end;


begin
 New(Hist);
end.