unit JS_PROJ;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_tio,js_koor,js_stm,js_mtr,js_gra,js_nnt,
 matrix,js_zepas;



Type
 Vector_3  = Array [1..3] of Real;

 PlotDatMono_T = record
                 xa,xe:Real; nx:Word; dx:Real;
                 ya,ye:Real; ny:Word; dy:Real;
                 zfeld: array[1..51,1..51] of Real;
                 end;

 PlotDatMono_P = ^PlotDatMono_T;

 PlotDat_T = record
             xa,xe:Real; nx:Word; dx:Real;
             ya,ye:Real; ny:Word; dy:Real;
             zfeld: array[1..51,1..51] of Real;
             color: array[1..51,1..51] of Byte;
             end;

 PlotDat_P = ^Plotdat_T;

 ColorLst_T =   array [32..255] of Byte;



Const
 Nz=10;

Var
 Koor3DRdDflt, Koor3DRdDatei, Koor3DSvDatei         : PathStr;
 ProjParRdDflt,ProjParRdDatei,ProjParSvDatei,PrjPfad: PathStr;
 PlotParRdDflt,PlotParRdDatei,PlotParSvDatei,PlpPfad: PathStr;
               PlotDatRdDatei,PlotDatSvDatei,PldPfad: PathStr;

 Ursprung:        Vector_3;
 Achslaenge:      Real;
 PosZAchse:       Word;
 MdMarkxy:        Word;
 MdBeschrxy:      Word;
 FmtMxy:          Word;
 FmtNxy:          Word;
 MdMarkz:         Word;
 MdBeschrz:       Word;
 FmtMz:           Word;
 FmtNz:           Word;
 Textx:           String;
 Texty:           String;
 Textz:           String;

 Koor3dColor:      Word;
 Koor3dLineStyle:  Word;
 RasterColor:      Word;
 RasterLineStyle:  Word;
 PlotFktColor:     Word;
 PlotFktLineStyle: Word;

 RotateZ:         Boolean;
 TkZC,TkZS:       Real;
 Augpkt:          Vector_3;
 WinZ:            Real;
 Hide:            Boolean;
 Hidden:          Boolean;
 Hiding:          Boolean;
 HightLines:      Boolean;

 Umriss:          Array [0..639,1..2] of integer;
 PlotDat:         PlotDat_P;

 ZMax:            Real;
 WMax:            Real;
 ClipUnten:       Real;
 ClipOben:        Real;

 KlfGeladen:      Boolean;
 NntGeladen:      Boolean;
 StModGeladen:    Boolean;
 Klanz:           Word;
 SlctLabel:       Char;
 GlbwSchw:        Real;
 QmkDat:          KlfDat_T;
 ColorLst:        ColorLst_T;
 WidthFak:        Real;


procedure PfadeInitProj(PfadeMaske:MskPar_T);
procedure ColorInitProj(FarbeMaske:MskPar_T);
procedure Koor3DInit(Koor3D:MskPar_T);
procedure ProjParInit(ProjPar:MskPar_T);
procedure PlotParInit(PlotPar:MskPar_T);

procedure SetV3(v1,v2,v3:Real; Var v:Vector_3);
procedure AddV3(v1,v2:Vector_3; Var v:Vector_3);
procedure SubV3(v1,v2:Vector_3; Var v:Vector_3);

procedure RotateZInit(WinZ: Real);
procedure PlotPkt3D(v:Vector_3; farbe:Word);
procedure PlotSymb3D(v:Vector_3; ch:Char);
procedure PlotTxt3D(v:Vector_3; s:String);

procedure HPutPixel(x,y:Integer);
procedure HMoveTo(x,y:Integer);
procedure HLineTo(x,y:Integer);
procedure ClrUmriss;
procedure HMoveToV(v:Vector_2);
procedure HLineToV(v:Vector_2);

procedure HMove3D(v:Vector_3);
procedure HLine3D(v:Vector_3);

procedure PlotKoor3D(Achslaenge:Real; Ursprung:Vector_3);
procedure Raster(Achslaenge:Real; Ursprung: Vector_3);
procedure Plot3D(Achslaenge:Real; Ursprung:Vector_3);
procedure GenPlotDat;
procedure SavePlotDat(PlotDatSvDatei:PathStr; PlotDat:PlotDat_P; Var OK:Boolean);
procedure LoadPlotDat(PlotDatRdDatei:PathStr; Var PlotDat:PlotDat_P; Var OK:Boolean);
procedure LoadPlotDatMono(PlotDatRdDatei:PathStr; Var PlotDat:PlotDat_P; Var OK:Boolean);
procedure MaxPlotDat(Var ZMax:Real);
procedure ClipPlotDat(Unten,Oben:Real);
procedure SkalPlotDat(Fak:Real);

procedure GenPlotDatFromKlf(ClSlct:SetChar_T);
procedure GenPlotDatAltFromKlf(GlbwSchw:Real);
procedure GenPlotDatRadFromKlf;
procedure GenPlotDatFromNnt(ClSlct:SetChar_T);

procedure GenPlotDatFromStMod(ClsSlct:SetChar_T);
procedure ColorListInit(ClSlct:SetChar_T; Var ColorLst:ColorLst_T);

procedure WidenStMod(Var StMod:StMod_T);


Implementation

procedure PfadeInitProj(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=     PfadeMaske.erg[ 1];
 KoorRdDflt:=   PfadeMaske.erg[ 2];
 Koor3DRdDflt:= PfadeMaske.erg[ 3];
 FarbePfad:=    PfadeMaske.erg[ 4];
 FarbeRdDflt:=  PfadeMaske.erg[ 5];
 PrjPfad:=      PfadeMaske.erg[ 6];
 ProjParRdDflt:=PfadeMaske.erg[ 7];
 PlpPfad:=      PfadeMaske.erg[ 8];
 PlotParRdDflt:=PfadeMaske.erg[ 9];
 KlfPfad:=      PfadeMaske.erg[10];
 ZKlfPfad:=     PfadeMaske.erg[11];
 ZRdbPfad:=     PfadeMaske.erg[12];
 NntPfad:=      PfadeMaske.erg[13];
 StModPfad:=    PfadeMaske.erg[14];
 PldPfad:=      PfadeMaske.erg[15];
 CnfPfad:=      PfadeMaske.erg[16];
 EditorPfad:=   PfadeMaske.erg[17];

 KoorRdDatei:=   KoorRdDflt;
 Koor3DRdDatei:= Koor3DRdDflt;
 FarbeRdDatei:=  FarbeRdDflt;
 ProjParRdDatei:=ProjParRdDflt;
 PlotParRdDatei:=PlotParRdDflt;
 end;


procedure ColorInitProj(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 Koor3dColor:=       ColorFromStr(FarbeMaske.erg[4]);
 Koor3dLineStyle:=   ValI(Trim(FarbeMaske.erg[5]));
 RasterColor:=       ColorFromStr(FarbeMaske.erg[6]);
 RasterLineStyle:=   ValI(Trim(FarbeMaske.erg[7]));
 PlotFktColor:=      ColorFromStr(FarbeMaske.erg[8]);
 PlotFktLineStyle:=  ValI(Trim(FarbeMaske.erg[9]));
 end;

procedure Koor3DInit(Koor3D:MskPar_T);
 begin
 Ursprung[1]:=     ValR(Trim(Koor3D.erg[ 1]));
 Ursprung[2]:=     ValR(Trim(Koor3D.erg[ 2]));
 Ursprung[3]:=     ValR(Trim(Koor3D.erg[ 3]));
 Achslaenge:=      ValR(Trim(Koor3D.erg[ 4]));
 WMax:=            ValR(Trim(Koor3D.erg[ 5]));
 PosZAchse:=       ValI(Trim(Koor3D.erg[ 6]));
 MdMarkxy:=        ValI(Trim(Koor3D.erg[ 7]));
 MdBeschrxy:=      ValI(Trim(Koor3D.erg[ 8]));
 FmtMxy:=          ValI(Trim(Koor3D.erg[ 9]));
 FmtNxy:=          ValI(Trim(Koor3D.erg[10]));
 MdMarkz:=         ValI(Trim(Koor3D.erg[11]));
 MdBeschrz:=       ValI(Trim(Koor3D.erg[12]));
 FmtMz:=           ValI(Trim(Koor3D.erg[13]));
 FmtNz:=           ValI(Trim(Koor3D.erg[14]));
 Textx:=           Trim(Koor3D.erg[15]);
 Texty:=           Trim(Koor3D.erg[16]);
 Textz:=           Trim(Koor3D.erg[17]);
 end;

procedure ProjParInit(ProjPar:MskPar_T);
 Var s:String;
 begin
 Augpkt[1]:=       ValR(Trim(ProjPar.erg[1]));
 Augpkt[2]:=       ValR(Trim(ProjPar.erg[2]));
 Augpkt[3]:=       ValR(Trim(ProjPar.erg[3]));
 WinZ:=            ValR(Trim(ProjPar.erg[4]));
 s:=               Trim(ProjPar.erg[5]);
 Hide:=            (s[1] in ['j','J']);
 s:=               Trim(ProjPar.erg[6]);
 HightLines:=      (s[1] in ['j','J']);

 RotateZInit(winZ);
 end;

procedure PlotParInit(PlotPar:MskPar_T);
 begin
 with PlotDat^ do
  begin
  xa:= ValR(Trim(PlotPar.erg[1]));
  xe:= ValR(Trim(PlotPar.erg[2]));
  nx:= ValI(Trim(PlotPar.erg[3]));
  ya:= ValR(Trim(PlotPar.erg[4]));
  ye:= ValR(Trim(PlotPar.erg[5]));
  ny:= ValI(Trim(PlotPar.erg[6]));
  dx:=(xe-xa)/(nx-1);
  dy:=(ye-ya)/(ny-1);
  end;
 end;

procedure SetV3(v1,v2,v3:Real; Var v:Vector_3);
 begin v[1]:=v1; v[2]:=v2; v[3]:=v3;
 end;

procedure AddV3(v1,v2:Vector_3; Var v:Vector_3);
 begin v[1]:=v1[1]+v2[1]; v[2]:=v1[2]+v2[2]; v[3]:=v1[3]+v2[3]; end;

procedure SubV3(v1,v2:Vector_3; Var v:Vector_3);
 begin v[1]:=v1[1]-v2[1]; v[2]:=v1[2]-v2[2]; v[3]:=v1[3]-v2[3]; end;

procedure RotateZInit(WinZ: Real);
 Var a:Real;
 begin
 if abs(WinZ)<0.001 then RotateZ:=False
                    else begin
                         RotateZ:=True;
                         a:=PI/180*WinZ;
                         TkZC:=cos(a); TkZS:=sin(a);
                         end;
 end;

procedure Proj3D(v:Vector_3; Var b:Vector_2);
 Var v1,v2,f1,f2:Real;
 begin
 if RotateZ then begin
                 v1:=  TkZC*v[1]-TkZS*v[2];
                 v[2]:=TkZS*v[1]+TkZC*v[2];
                 v[1]:=v1;
                 end;
 f1:=v[2]/Augpkt[2];
 f2:=1/(1-f1);
 b[1]:=f2*(v[1]-f1*Augpkt[1]);
 b[2]:=f2*(v[3]-f1*Augpkt[3]);
 end;

procedure PlotPkt3D(v:Vector_3; farbe:Word);
 Var b:Vector_2;
 begin Proj3D(v,b); PlotV(b,farbe); end;

procedure PlotSymb3D(v:Vector_3; ch:Char);
 Var b:Vector_2;
 begin Proj3D(v,b); PlotSymbV(b,ch); end;

procedure PlotTxt3D(v:Vector_3; s:String);
 Var b:Vector_2; x,y:Integer;
 begin
 Proj3D(v,b);
 x:=XS(XF(b[1])); y:=YS(YF(b[2]));
 if not Hidden then WriteXYG(x,y,s)
               else if (y<Umriss[x,1]) or (y>Umriss[x,2]) then WriteXYG(x,y,s);
 end;

procedure HPutPixel(x,y:Integer);
 begin
  if not hidden then LPutPixel(x,y)
                else begin
                     if Umriss[x,1]>Umriss[x,2] then
                      begin
                      Umriss[x,1]:=y;
                      Umriss[x,2]:=y;
                      LPutPixel(x,y);
                      end
                     else
                      begin
                      if      y<Umriss[x,1] then
                       begin
                       LPutPixel(x,y);
                       if Hiding then Umriss[x,1]:=y;
                       end
                      else if y>Umriss[x,2] then
                       begin
                       LPutPixel(x,y);
                       if Hiding then Umriss[x,2]:=y;
                       end;
                      end;
                     end;
 end;

procedure HMoveTo(x,y:Integer);
 begin
 p_mst:=1; HPutPixel(x,y); x_vrg:=x; y_vrg:=y; 
 end;

procedure HLineTo(x,y:Integer);
 Var delx,dely,j:Integer; mm:Real;
 begin
 delx:=x-x_vrg; dely:=y-y_vrg;
 case ( Abs(delx) >= Abs(dely) ) of
  TRUE : begin
         if delx<>0 then
          begin
          mm:=dely/delx;
          if delx>0 then for j:= 1     to delx do HPutPixel(x_vrg+j,y_vrg+round(mm*j))
                    else for j:=-1 downto delx do HPutPixel(x_vrg+j,y_vrg+round(mm*j));
          end;
         end;
  FALSE: begin
         if dely<>0 then
          begin
          mm:=delx/dely;
          if dely>0 then for j:=dely downto  1 do HPutPixel(x_vrg+round(mm*j),y_vrg+j)
                    else for j:=-1 downto dely do HPutPixel(x_vrg+round(mm*j),y_vrg+j);
          end;
         end;
  end;
 x_vrg:=x; y_vrg:=y;
 end;

procedure ClrUmriss;
 VAR x:Integer;
 begin
 for x:=0 to 639 do
  begin
  Umriss[x,1]:=349;
  Umriss[x,2]:=0;
  end;
 end;

procedure HMoveToV(v:Vector_2);
 begin HMoveTo(XS(XF(v[1])),YS(YF(v[2]))); end;

procedure HLineToV(v:Vector_2);
 begin HLineTo(XS(XF(v[1])),YS(YF(v[2]))); end;

procedure HMove3D(v:Vector_3);
 Var b:Vector_2;
 begin Proj3D(v,b); HMoveToV(b); end;

procedure HLine3D(v:Vector_3);
 Var b:Vector_2;
 begin Proj3D(v,b); HLineToV(b); end;


procedure PlotKoor3D(Achslaenge:Real; Ursprung:Vector_3);

 Const
  s=2; a=8; zb=4;

 Var
  s1,s2,s3,a1,a2,a3,p,p1,pz: Vector_3;
  i,j:Word;
  delx,dely,delz:Real;
  w:Real;

 begin

 if Hide then begin Hidden:=TRUE; Hiding:=FALSE; end
         else Hidden:=FALSE;

 SetV3(s,0,0,s1);             SetV3(0,s,0,s2);          SetV3(0,0,s,s3);
 SetV3(-FmtMxy/2*zb,-a,0,a1); SetV3(-FmtMxy*zb,2,0,a2); SetV3(-FmtMz*zb-a,0,2,a3);
 case PosZAchse of
  0: SetV3(         0,         0,0,pz);
  1: SetV3(         0,Achslaenge,0,pz);
  2: SetV3(Achslaenge,Achslaenge,0,pz);
  3: SetV3(Achslaenge,         0,0,pz);
 end;
 AddV3(Ursprung,pz,pz);

 TextColor(Koor3DColor); TextBackGround(DskTpColor[1]);

 p:=Ursprung; p[1]:=p[1]+Achslaenge; HMove3D(Ursprung); HLine3D(p);
 p:=Ursprung; p[2]:=p[2]+Achslaenge; HMove3D(Ursprung); HLine3D(p);
 p:=pz;       p[3]:=p[3]+Achslaenge; HMove3D(pz);       HLine3D(p);

 p:=Ursprung; p[1]:=p[1]+Achslaenge/2;  p[2]:=p[2]-30; PlotTxt3D(p,Textx);
 p:=Ursprung; p[2]:=p[2]+Achslaenge/2;  p[1]:=p[1]-30; PlotTxt3D(p,Texty);
 p:=pz;       p[3]:=p[3]+Achslaenge+10;                PlotTxt3D(p,Textz);

 with PlotDat^ do
  begin

  delx:=Achslaenge/(nx-1);
  dely:=Achslaenge/(ny-1);
  delz:=Achslaenge/Nz;

  SetTextJustify(LeftText,TopText);
  p:=Ursprung;
  for i:=0 to nx-1 do
   begin
   if (i mod MdMarkxy)=0 then
    begin HMove3D(p); SubV3(p,s2,p1); HLine3D(p1); end;
   if (i mod MdBeschrxy)=0 then
    begin
    AddV3(p,a1,p1); PlotTxt3D(p1,StrR(xa+dx*i,FmtMxy,FmtNxy));
    end;
   p[1]:=p[1]+delx;
   end;

  p:=Ursprung;
  for j:=0 to ny-1 do
   begin
   if (j mod MdMarkxy)=0 then
    begin HMove3D(p); SubV3(p,s1,p1); HLine3D(p1); end;
   if (j mod MdBeschrxy)=0 then
    begin
    AddV3(p,a2,p1); PlotTxt3D(p1,StrR(ya+dy*j,FmtMxy,FmtNxy));
    end;
   p[2]:=p[2]+dely;
   end;

  p:=pz;
  for i:=1 to nz do
   begin
   p[3]:=p[3]+delz;
   HMove3D(p); SubV3(p,s1,p1); HLine3D(p1);
   if (i mod MdBeschrz)=0 then
    begin
    AddV3(p,a3,p1); PlotTxt3D(p1,StrR(i/nz*WMax,FmtMz,FmtNz));
    end;
   end;

  end;
 end;


procedure Raster(Achslaenge:Real; Ursprung: Vector_3);

 Var
  i,j:Word; p,p1:Vector_3; delx,dely:Real;

 begin
 if Hide then begin Hidden:=TRUE; Hiding:=FALSE; end
         else Hidden:=FALSE;
 with PlotDat^ do
  begin
  delx:=Achslaenge/(nx-1);
  dely:=Achslaenge/(ny-1);

  p:=Ursprung;
  p1:=p; p1[1]:=p1[1]+Achslaenge;
  for j:=1 to ny-1 do
   begin
   p[2]:=p[2]+dely; p1[2]:=p1[2]+dely;
   if (j mod MdMarkxy)=0 then begin HMove3D(p); HLine3D(p1); end;
   end;

  p:=Ursprung;
  p1:=p; p1[2]:=p1[2]+Achslaenge;
  for i:=1 to nx-1 do
   begin
   p[1]:=p[1]+delx; p1[1]:=p1[1]+delx;
   if (i mod MdMarkxy)=0 then begin HMove3D(p); HLine3D(p1); end;
   end;

  end;
 end;


procedure Plot3D(Achslaenge:Real; Ursprung:Vector_3);

  Var
   i,j,h:Word;
   p,p1:Vector_3;
   delx,dely,delh:Real;
   p1alt,p2alt,p3alt:Real;
   ch:Char; fak:Real;
   Above:Boolean;
   aktcolor,lastcolor:Byte;

 procedure HightLinePatch(i,j:Word; h:Real; Var Above:Boolean);

  Const
   GrenzColor=LightGray;

  Var
   w1,w2,w3,w4: Real;
   b1,b2,b3,b4: Boolean;
   c1,c2,c3,c4: Byte;
   pf: Array [1..2] of Vector_3;
   pc: Array [1..2] of Byte;
   anzp: Word;
   p: Vector_3;

  begin
  pf[1,3]:=h;
  pf[2,3]:=h;
  with PlotDat^ do
   begin
   anzp:=0;
   w1:=fak*zfeld[i  ,j  ]-h; b1:=(w1>0); c1:=color[i  ,j  ];
   w2:=fak*zfeld[i+1,j  ]-h; b2:=(w2>0); c2:=color[i+1,j  ];
   w3:=fak*zfeld[i+1,j+1]-h; b3:=(w3>0); c3:=color[i+1,j+1];
   w4:=fak*zfeld[i  ,j+1]-h; b4:=(w4>0); c4:=color[i  ,j+1];
   Above:=not (b1 or b2 or b3 or b4);
   if b1 xor b2 then
    begin
    anzp:=succ(anzp);
    pf[anzp,1]:=(i+w2/(w1-w2))*delx;
    pf[anzp,2]:=(j-1)*dely;
    if c1=c2 then pc[anzp]:=c1 else pc[anzp]:=GrenzColor;
    end;
   if b2 xor b3 then
    begin
    anzp:=succ(anzp);
    pf[anzp,1]:=i*delx;
    pf[anzp,2]:=(j+w3/(w2-w3))*dely;
    if c2=c3 then pc[anzp]:=c2 else pc[anzp]:=GrenzColor;
    end;
   if (anzp<2) and (b3 xor b4) then
    begin
    anzp:=succ(anzp);
    pf[anzp,1]:=(i+w3/(w4-w3))*delx;
    pf[anzp,2]:=j*dely;
    if c3=c4 then pc[anzp]:=c3 else pc[anzp]:=GrenzColor;
    end;
   if (anzp<2) and (b4 xor b1) then
    begin
    anzp:=succ(anzp);
    pf[anzp,1]:=(i-1)*delx;
    pf[anzp,2]:=(j+w4/(w1-w4))*dely;
    if c4=c1 then pc[anzp]:=c4 else pc[anzp]:=GrenzColor;
    end;
   if anzp=2 then
    begin
    if pc[1]=pc[2] then SetColor(pc[1]) else SetColor(GrenzColor);
    AddV3(pf[1],Ursprung,p); HMove3D(p); AddV3(pf[2],Ursprung,p); HLine3D(p);
    end;
   end;
  end;

 begin
 if Hide then begin Hidden:=True;  Hiding:=True;  ClrUmriss; end
         else begin Hidden:=False; Hiding:=False; end;

 fak:=Achslaenge/Wmax;


 with PlotDat^ do
  begin

  delx:=Achslaenge/(nx-1);
  dely:=Achslaenge/(ny-1);
  if HightLines then delh:=Achslaenge/Nz;

  {erste Linie in x-Richtung malen}
  lastcolor:=color[1,1];
  p:=Ursprung; p[3]:=Ursprung[3]+fak*zfeld[1,1]; HMove3D(p);
  for i:=2 to nx do
   begin
   aktcolor:=color[i,1];
   if aktcolor=lastcolor then SetColor(aktcolor) else SetColor(LightGray);
   lastcolor:=aktcolor;
   p[1]:=p[1]+delx; p[3]:=Ursprung[3]+fak*zfeld[i,1]; HLine3D(p);
   end;

  {Netz malen}
  for j:=2 to ny do
   begin
   {ersten Schritt in y-Richtung malen}
   lastcolor:=color[1,j-1];
   p[1]:=Ursprung[1];                 p[3]:=Ursprung[3]+fak*zfeld[1,j-1]; HMove3D(p);

   aktcolor:=color[1,j];
   if aktcolor=lastcolor then SetColor(aktcolor) else SetColor(LightGray);
   lastcolor:=aktcolor;
                     p[2]:=p[2]+dely; p[3]:=Ursprung[3]+fak*zfeld[1,j];   HLine3D(p);
   for i:=2 to nx do
    begin
    if HightLines then
     begin
     {Hhenlinien malen}
     if Hidden then Hiding:=False;
     Above:=False;
     for h:=0 to nz do if not Above then HightLinePatch(i-1,j-1,h*delh,Above);
     if Hidden then Hiding:=True;
     end;
    {Masche malen}
    lastcolor:=color[i,j-1];
    p[1]:=p[1]+delx; p[2]:=p[2]-dely; p[3]:=Ursprung[3]+fak*zfeld[i,j-1]; Hmove3D(p);
    aktcolor:=color[i,j];
    if aktcolor=lastcolor then SetColor(aktcolor) else SetColor(LightGray);
    lastcolor:=aktcolor;
                     p[2]:=p[2]+dely; p[3]:=Ursprung[3]+fak*zfeld[i,j];   Hline3D(p);
    p1alt:=p[1]; p2alt:=p[2]; p3alt:=p[3];
    lastcolor:=color[i-1,j];
    p[1]:=p[1]-delx;                  p[3]:=Ursprung[3]+fak*zfeld[i-1,j]; HMove3D(p);
    aktcolor:=color[i,j];
    if aktcolor=lastcolor then SetColor(aktcolor) else SetColor(LightGray);
    lastcolor:=aktcolor;
    p[1]:=p1alt;     p[2]:=p2alt;     p[3]:=p3alt;                    Hline3D(p);
    end;

   if KeyPressed then begin ch:=ReadKey; EXIT; end;

   end;
  end;
 end;


procedure GenPlotDat;
 Var i,j:Word; x,y:Real;
 begin
 with PlotDat^ do
  begin
  xa:=-1; xe:=1; nx:=51; dx:=(xe-xa)/(nx-1);
  ya:=-1; ye:=1; ny:=51; dy:=(ye-ya)/(ny-1);
  y:=ya;
  for j:=1 to ny do
   begin
   x:=xa; for i:=1 to nx do
    begin
    zfeld[i,j]:=MaxR(cos(sqr(x)+sqr(y)),0);
    color[i,j]:=Trunc(5*zfeld[i,j])+1;
    x:=x+dx;
    end;
   y:=y+dy;
   end;
  end;
 end;


procedure SavePlotDat(PlotDatSvDatei:PathStr; PlotDat:PlotDat_P; Var OK:Boolean);
 Var f: file of PlotDat_T;
 begin
 Assign(f,PlotDatSvDatei); {$I-} Rewrite(f) {$I+}; OK:=(IOResult=0);
 if OK then begin Write(f,PlotDat^); Close(f); end;
 end;


procedure LoadPlotDat(PlotDatRdDatei:PathStr; Var PlotDat:PlotDat_P; Var OK:Boolean);
 Var f: file of PlotDat_T;
 begin
 Assign(f,PlotDatRdDatei); {$I-} Reset(f) {$I+}; OK:=(IOResult=0);
 if OK then begin
            {$I-} Read(f,PlotDat^); {$I+}; OK:=(IOResult=0);
            if OK then Close(f);
            end;
 end;


procedure LoadPlotDatMono(PlotDatRdDatei:PathStr; Var PlotDat:PlotDat_P; Var OK:Boolean);
 Var
  f: file of PlotDatMono_T;
  PlotDatMono:PlotDatMono_P;
  i,j: Word;
 begin
 Assign(f,PlotDatRdDatei); {$I-} Reset(f) {$I+}; OK:=(IOResult=0);
 if OK then begin
            New(PlotDatMono);
            Read(f,PlotDatMono^);
            Close(f);
            with PlotDatMono^ do begin
                                 PlotDat^.xa:=xa;
                                 PlotDat^.xe:=xe;
                                 PlotDat^.nx:=nx;
                                 PlotDat^.dx:=dx;
                                 PlotDat^.ya:=ya;
                                 PlotDat^.ye:=ye;
                                 PlotDat^.ny:=ny;
                                 PlotDat^.dy:=dy;
                                 for i:=1 to 51 do
                                  for j:=1 to 51 do
                                   begin
                                   PlotDat^.zfeld[i,j]:=zfeld[i,j];
                                   PlotDat^.color[i,j]:=PlotFktColor;
                                   end;
                                 end;
            Dispose(PlotDatMono);
            end;
 end;


procedure MaxPlotDat(Var ZMax:Real);
 Var i,j:Word;
 begin
 with PlotDat^ do
  begin
  ZMax:=0;
  for j:=1 to ny do for i:=1 to nx do
   ZMax:=MaxR(zfeld[i,j],ZMax);
  end;
 end;

procedure ClipPlotDat(Unten,Oben:Real);
 Var i,j:Word;
 begin
 with PlotDat^ do
  for j:=1 to ny do for i:=1 to nx do
   zfeld[i,j]:=MaxR(MinR(zfeld[i,j],Oben),Unten);
 end;

procedure SkalPlotDat(Fak:Real);
 Var i,j:Word;
 begin
 with PlotDat^ do
  for j:=1 to ny do for i:=1 to nx do
   zfeld[i,j]:=Fak*zfeld[i,j];
 end;


procedure GenPlotDatFromKlf(ClSlct:SetChar_T);
 Var i,j,k:Word; x,y,d:Real; v:Vector_2;
 begin
 with PlotDat^ do
  begin
  y:=ya;
  for j:=1 to ny do
   begin
   x:=xa; for i:=1 to nx do
    begin
    SetV(x,y,v);

    case ModeKlf of
     stm: DVekt(KlfDat,v,SmplClass,ErkErg);
     zep: DVektZep(Psl,ClsLst,Koeff,v,SmplClass,ErkErg);
    end;

    with ErkErg do
     begin
     if ClSlct<>[] then
      begin
      d:=0;
      for k:=1 to anz do if labl[k] in ClSlct then d:=MaxR(d,glbw[k]);
      zfeld[i,j]:=d;
      end
     else
      begin
      zfeld[i,j]:=glbw[1];
      end;
     color[i,j]:=ColorLst[Ord(labl[1])];
     end;

    x:=x+dx;
    end;
   y:=y+dy;
   end;
  end;
 end;


procedure GenPlotDatAltFromKlf(GlbwSchw:Real);
 Var i,j,a:Word; x,y,sum:Real; v:Vector_2;
 begin
 with PlotDat^ do
  begin
  y:=ya;
  for j:=1 to ny do
   begin
   x:=xa; for i:=1 to nx do
    begin
    SetV(x,y,v);

    case ModeKlf of
     stm: DVekt(KlfDat,v,SmplClass,ErkErg);
     zep: DVektZep(Psl,ClsLst,Koeff,v,SmplClass,ErkErg);
    end;

    a:=1; sum:=ErkErg.glbw[1];
    while (sum<GlbwSchw) and (a<ErkErg.anz) do begin Inc(a); sum:=sum+ErkErg.glbw[a]; end;

    if sum=0 then a:=0;
    zfeld[i,j]:=a;
    color[i,j]:=ColorLst[Ord(ErkErg.labl[1])];

    x:=x+dx;
    end;
   y:=y+dy;
   end;
  end;
 end;


procedure GenPlotDatRadFromKlf;
 Var i,j,a:Word; x,y,sum:Real; v:Vector_2;
 begin
 with PlotDat^ do
  begin
  y:=ya;
  for j:=1 to ny do
   begin
   x:=xa; for i:=1 to nx do
    begin
    SetV(x,y,v);

    case ModeKlf of
     stm: DVekt(KlfDat,v,SmplClass,ErkErg);
     zep: DVektZep(Psl,ClsLst,Koeff,v,SmplClass,ErkErg);
    end;

    zfeld[i,j]:=ErkErg.radqnxt;
    color[i,j]:=ColorLst[Ord(ErkErg.labl[1])];
    x:=x+dx;
    end;
   y:=y+dy;
   end;
  end;
 end;


procedure GenPlotDatFromStMod(ClsSlct:SetChar_T);
 Var
  i,j,k,n:Word; x,y,sum,prb,maxprb:Real;
  v,v1:Vector_2; a,xv:Vector_6;
  lastcl,aktcl,maxcl:Char;

 begin
 with PlotDat^ do
  begin
  y:=ya;
  for j:=1 to ny do
   begin
   x:=xa; for i:=1 to nx do
    begin
    SetV(x,y,v);

    VqPV(v,xv);
    with QmkDat do
     begin
     prb:=0; lastcl:=' '; maxprb:=0;
     for k:=1 to anz do
      begin
      aktcl:=dat[k].class;
      if aktcl<>lastcl then begin
                            if prb>maxprb then begin
                                               maxprb:=prb;
                                               maxcl:=lastcl;
                                               end;
                            lastcl:=aktcl;
                            prb:=0;
                            end;
      sum:=0;
      if (ClSlct=[]) or (aktcl in ClSlct) then
       begin
       with dat[k] do for n:=1 to 6 do sum:=sum+koeff[n]*xv[n];
       sum:=exp(MaxR(-70,sum));
       end;
      prb:=prb+sum;
      end;
     if prb>maxprb then begin
                        maxprb:=prb;
                        maxcl:=aktcl;
                        end;
     end;

    zfeld[i,j]:=maxprb;
    color[i,j]:=ColorLst[Ord(maxcl)];

    x:=x+dx;
    end;
   y:=y+dy;
   end;
  end;
 end;


procedure ColorListInit(ClSlct:SetChar_T; Var ColorLst:ColorLst_T);
 Var   i,j:Word;
 begin
 j:=0;
 for i:=32 to 255 do
  if Chr(i) in ClSlct then begin
                           ColorLst[i]:=ClassColor[j mod 12];
                           Inc(j);
                           end
                      else ColorLst[i]:=PlotFktColor;
 end;



procedure GenPlotDatFromNnt(ClSlct:SetChar_T);
 Var i,j,k:Word; x,y,d:Real; v:Vector_2;
 begin
 with PlotDat^ do
  begin
  y:=ya;
  for j:=1 to ny do
   begin
   x:=xa; for i:=1 to nx do
    begin
    SetV(x,y,v);
    DVektNnt(Netz,v,SmplClass,ErkErg);

    with ErkErg do
     begin
     if ClSlct<>[] then 
      begin
      d:=0;
      for k:=1 to anz do if labl[k] in ClSlct then d:=MaxR(d,glbw[k]);
      zfeld[i,j]:=d;
      end
     else
      begin
      zfeld[i,j]:=glbw[1];
      end;
     color[i,j]:=ColorLst[Ord(labl[1])];
     end;

    x:=x+dx;
    end;
   y:=y+dy;
   end;
  end;
 end;


procedure WidenStMod(Var StMod:StMod_T);
 Var   i:Word;
 begin
 with StMod do for i:=1 to anz do with tab[i] do
                begin
                eigv1:=Sqr(WidthFak)*eigv1;
                eigv2:=Sqr(WidthFak)*eigv2;
                end;
 end;


begin
end.
