unit JS_QMX;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_koor,js_stm,js_mtr,js_gra,js_mat;


Type
 EigFrmHist_P   = ^EigFrmHist_T;
 EigFrmHist_T   = array [0..AnzIntv+1,1..AnzElemMod,1..2] of Word;
 EigFrmModRec_T = record
                   anzeig:  Word;
                   meaneig: Real;
                   sigmeig: Real;
                   anzfrm:  Word;
                   meanfrm: Real;
                   sigmfrm: Real;
                  end;
 EigFrmMod_T    = array [1..AnzElemMod] of EigFrmModRec_T;

Var
 HistPfad,             HistRdDatei, HistSvDatei: PathStr;


 EigHistColor:     Word;
 EigHistLineStyle: Word;
 FrmHistColor:     Word;
 FrmHistLineStyle: Word;
 GlaubwColor:      Word;
 GlaubwLineStyle:  Word;
 GlaubwFaktor:     Real;
 AnzSmpl:          Word;
 DVkt:             DVkt_T;
 Hist:             EigFrmHist_P;
 HistType:         Byte;
 HistFertig:       Boolean;
 SlctLabel:        Char;
 EigFrmMod:        EigFrmMod_T;
 EigFrmModFertig:  Boolean;
 SrcDVekt:         Boolean;
 KlfGeladen:       Boolean;
 RdDatei:          PathStr;
 FktStchp:         Word;


procedure PfadeInitQMX(PfadeMaske: MskPar_T);
procedure ColorInitQMX(FarbeMaske:MskPar_T);

function  FachNr(x:Real):Word;
procedure ClrEigFrmHist;
procedure SaveEigFrmHist(HistSvDatei:PathStr; OK:Boolean);
procedure LoadEigFrmHist(HistRdDatei:PathStr; OK:Boolean);
procedure EigFrmHistogramm(RdDatei:PathStr; OK:Boolean);
procedure PlotEigFrmHist(SlctLabel:Char; HistType:Byte);

procedure ClrEigFrmMod;
procedure AkkumEigFrmMod(d:Real; k:Word; i:Word);
procedure CmpltEigFrmMod;
procedure EigFrmModFromHist;
procedure EigFrmModFromMom(RzpDat:RzpDat_T; MomPfad:PathStr; KlfDat:KlfDat_T; OK:Boolean);
procedure PlotNvt(SlctLabel:Char; HistType:Byte);
procedure PlotGlbw(SlctLabel:Char);

procedure KmplKlf(Var KlfDat:KlfDat_T);



Implementation

procedure PfadeInitQMX(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=   PfadeMaske.erg[ 1];
 KoorRdDflt:= PfadeMaske.erg[ 2];
 FarbePfad:=  PfadeMaske.erg[ 3];
 FarbeRdDflt:=PfadeMaske.erg[ 4];
 DVektPfad:=  PfadeMaske.erg[ 5];
 HistPfad:=   PfadeMaske.erg[ 6];
 KlfPfad:=    PfadeMaske.erg[ 7];
 ZKlfPfad:=   PfadeMaske.erg[ 8];
 ZRdbPfad:=   PfadeMaske.erg[ 9];
 StchpPfad:=  PfadeMaske.erg[10];
 RzpPfad:=    PfadeMaske.erg[11];
 MomPfad:=    PfadeMaske.erg[12];
 EditorPfad:= PfadeMaske.erg[13];

 KoorRdDatei:= KoorRdDflt;
 FarbeRdDatei:=FarbeRdDflt;
 end;

procedure ColorInitQMX(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 EigHistColor:=      ColorFromStr(FarbeMaske.erg[4]);
 EigHistLineStyle:=  ValI(Trim(FarbeMaske.erg[5]));
 FrmHistColor:=      ColorFromStr(FarbeMaske.erg[6]);
 FrmHistLineStyle:=  ValI(Trim(FarbeMaske.erg[7]));
 GlaubwColor:=       ColorFromStr(FarbeMaske.erg[8]);
 GlaubwLineStyle:=   ValI(Trim(FarbeMaske.erg[9]));
 GlaubwFaktor:=      ValR(Trim(FarbeMaske.erg[10]));
 FktStchp:=          ValI(Trim(FarbeMaske.erg[11]));
 end;

function  FachNr(x:Real):Word;
 begin
 FachNr:=MAXI(MinI(Trunc((x-XAnf)*Fak)+1,AnzIntv+1),0);
 end;

procedure ClrEigFrmHist;
 Var n,m,k:Word;
 begin
 for n:=0 to AnzIntv+1 do
  for k:=1 to KlAnz do for m:=1 to 2 do Hist^[n,k,m]:=0;
 end;


procedure SaveEigFrmHist(HistSvDatei:PathStr; OK:Boolean);
 Var f:text; n,m,k:Word; UntFachGrenze:Real;
 begin
 Assign(f,HistSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then
  begin
  writeln(f,'* Eigen/Fremd-Histogramme');
  writeln(f,'* -----------------------');
  if SrcDvekt then
   begin
   writeln(f,'* D-Vektoren aus .........: '+RdDatei);
   end
  else
   begin
   writeln(f,'* Klassifikator ..........: '+KlfRdDatei);
   writeln(f,'* Merkmals-Vektoren aus ..: '+RdDatei);
   end;
  writeln(f,'* Anzahl = '+StrI(AnzSmpl,0));
  writeln(f,'* --------------------------------------------');
  write(f,'* Label  =      ');
  for k:=1 to KlAnz do write(f,FillStr(ClsLst[k],12));
  writeln(f);
  write(f,'*  unt.Gr.');
  for k:=1 to KlAnz do write(f,' eigen fremd');
  writeln(f);
  UntFachGrenze:=XAnf;
  for n:=0 to AnzIntv+1 do
   begin
   if n=0 then write(f,-9.999:10:3)
          else begin
               write(f,UntFachGrenze:10:3);
               UntFachGrenze:=UntFachGrenze+XDel;
               end;
   for k:=1 to KlAnz do write(F,hist^[n,k,1]:6,
                                hist^[n,k,2]:6);
   writeln(f);
   end;        
  Close(f);
  end;
 end;

procedure LoadEigFrmHist(HistRdDatei:PathStr; OK:Boolean);
 Var f:text; n,k:Word; s,cs:String; DataFound:Boolean; dummy:Real;
 begin
 Assign(f,HistRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if Ok then
  begin
  n:=0; DataFound:=False;
  repeat
   readln(f,s);
   if s[1]='*' then
    begin
    GetPar(s);
    if ParStr(2)='Anzahl' then AnzSmpl:=ValI(ParStr(4));
    if ParStr(2)='Label'  then begin
                               for k:=4 to ParCount do begin
                                                       cs:=ParStr(k);
                                                       ClsLst[k-3]:=cs[1];
                                                       end;
                               KlAnz:=ParCount-3;
                               end;
    if ParStr(2)='unt.Gr.' then DataFound:=True;
    end;
  until DataFound;
  repeat
   read(f,dummy);
   for k:=1 to KlAnz do read(f,hist^[n,k,1],
                               hist^[n,k,2]);
   readln(f);
   Inc(n);
  until Eof(f);
  Close(f);
  end;
 end;

procedure EigFrmHistogramm(RdDatei:PathStr; OK:Boolean);
 Var f:Text; dv:DVkt_T; s,sc:String; i,k,m,n:Word; wert:Real;

 procedure GetDvekt;
  Var k:Word; v:Vector_2;
  begin
  if SrcDVekt then begin
                   ReadLn(f,s); GetPar(s);
                   sc:=ParStr(1); SmplClass:=sc[1];
                   for k:=3 to ParCount do dv[k-2]:=ValR(ParStr(k));
                   end
              else begin
                   ReadLn(f,SmplClass,SmplNr,v[1],v[2]);

                   case ModeKlf of
                    stm: DVekt(KlfDat,v,SmplClass,ErkErg);
                    zep: DVektZep(Psl,ClsLst,Koeff,v,SmplClass,ErkErg);
                   end;

                   dv:=ErkErg.dvkt;
                   end;
  end;


 begin
 Assign(f,RdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if OK then
  begin
  ClrEigFrmHist; ClrEigFrmMod; AnzSmpl:=0;
  repeat
   GetDvekt;
   if (SmplClass in ClSlct) then
     begin
     for k:=1 to KlAnz do
       begin
       wert:=dv[k];
       n:=FachNr(wert);
       if SmplClass=ClsLst[k] then m:=1 else m:=2;
       Inc(hist^[n,k,m]);
       AkkumEigFrmMod(wert,k,m);
       end;
     Inc(AnzSmpl);
     end;
  until Eof(f);
  Close(f);
  CmpltEigFrmMod;
  EigFrmModFertig:=True;
  end;
 end;


procedure PlotEigFrmHist(SlctLabel:Char; HistType:Byte);
 Var v:Vector_2; n,k,kk:Word; x,h:Real; eps:Real;
 begin
 if SlctLabel=#32 then k:=0
                  else begin
                       k:=1;
                       while not (ClsLst[k]=SlctLabel) do Inc(k);
                       end;
 x:=Xanf+0.5*XDel; eps:=0.2*XDel;
 for n:=1 to AnzIntv do
  begin
  if HistType in [0,2] then begin
                            SetColor(EigHistColor);
                            l_art:=LMuster[EigHistLineStyle];
                            SetV(x+eps,0,v); LMoveToV(v);
                            if k=0 then begin
                                        h:=0;
                                        for kk:=1 to KlAnz do h:=h+Hist^[n,kk,1];
                                        h:=h/KlAnz;
                                        end
                                   else h:=Hist^[n,k,1];
                            SetV(x+eps,h,v); LLineToV(v);
                            end;
  if HistType in [1,2] then begin
                            SetColor(FrmHistColor);
                            l_art:=LMuster[FrmHistLineStyle];
                            SetV(x-eps,0,v); LMoveToV(v);
                            if k=0 then begin
                                        h:=0;
                                        for kk:=1 to KlAnz do h:=h+Hist^[n,kk,2];
                                        h:=h/KlAnz;
                                        end
                                   else h:=Hist^[n,k,2];
                             SetV(x-eps,h,v); LLineToV(v);
                            end;
  x:=x+XDel;
  end;
 end;

procedure ClrEigFrmMod;
 Var k:Word;
 begin
 for k:=1 to AnzElemMod do with EigFrmMod[k] do
  begin
  anzeig:= 0; meaneig:=0; sigmeig:=0;
  anzfrm:= 0; meanfrm:=0; sigmfrm:=0;
  end;
 end;


procedure AkkumEigFrmMod(d:Real; k:Word; i:Word);
 begin
 with EigFrmMod[k] do
   case i of
    1: begin Inc(anzeig); meaneig:=meaneig+d; sigmeig:=sigmeig+sqr(d); end;
    2: begin Inc(anzfrm); meanfrm:=meanfrm+d; sigmfrm:=sigmfrm+sqr(d); end;
   end;
 end;


procedure CmpltEigFrmMod;
 var k:Word;
 begin
 for k:=1 to Klanz do with EigFrmMod[k] do
   begin
   meaneig:=meaneig/anzeig; sigmeig:=Sqrt(sigmeig/anzeig-Sqr(meaneig));
   meanfrm:=meanfrm/anzfrm; sigmfrm:=Sqrt(sigmfrm/anzfrm-Sqr(meanfrm));
   end;
 end;


procedure EigFrmModFromHist;
 Var n,k,m:Word;
     sumeig,sumfrm,heig,hfrm:Word;
     x,sumeigx,sumeigxx,sumfrmx,sumfrmxx:Real;
 begin
 for k:=1 to KlAnz do
  begin
  sumeig:=  0; sumeigx:= 0; sumeigxx:=0;
  sumfrm:=  0; sumfrmx:= 0; sumfrmxx:=0;
  x:=Xanf-0.5*Xdel;
  for n:=0 to AnzIntv+1 do begin
                           x:=x+XDel; heig:=Hist^[n,k,1]; hfrm:=Hist^[n,k,2];
                           sumeig:=  sumeig+  heig;
                           sumeigx:= sumeigx+ heig*x;
                           sumeigxx:=sumeigxx+heig*Sqr(x);
                           sumfrm:=  sumfrm+  hfrm;
                           sumfrmx:= sumfrmx+ hfrm*x;
                           sumfrmxx:=sumfrmxx+hfrm*Sqr(x);
                           end;
  with EigFrmMod[k] do
   begin
   anzeig:= sumeig;
   meaneig:=sumeigx/sumeig;
   sigmeig:=Sqrt(sumeigxx/sumeig-Sqr(meaneig));
   anzfrm:= sumfrm;
   meanfrm:=sumfrmx/sumfrm;
   sigmfrm:=Sqrt(sumfrmxx/sumfrm-Sqr(meanfrm));
   end;
  end;
 end;


procedure EigFrmModFromMom(RzpDat:RzpDat_T; MomPfad:PathStr; KlfDat:KlfDat_T; OK:Boolean);

 Var di:DirStr; na:NameStr; ex:ExtStr;
     Mom:MomRec_T;
     Cl:ClsLst_T;
     k,ks,zgr,nsc,keig,kk,n,m:Word;
     Klf:KlfDat_T;
     mxeig,mxfrm,a:Vector_6;
     mmeig,mmfrm:Matrix_6;
     cpeig,fak:Real;

 procedure AddMomMat(c:Real; k:Word; Mom:MomRec_T);
  Var i,j:Word;
  begin
  with MomDat^.dat[k] do
   for i:=1 to 6 do
    for j:=1 to 6 do
     matrx[i,j]:=matrx[i,j]+c*Mom.matrx[i,j];
  end;

 function Findcls(cls:Char):Word;
  Var k:Word;
  begin
  k:=1; while (cl[k]<>cls) and (k<=MomDat^.anz) do Inc(k);
  if k>MomDat^.anz then k:=0;
  Findcls:=k;
  end;

 begin
 FSplit(MomPfad,di,na,ex);
 ClearMom;
 with RzpDat do
  begin
  for k:=1 to anzcl do
   begin
   zgr:=  dat[k].zeigr;
   nsc:=  dat[k].anzsc;
   Cl[k]:=dat[zgr].class;
   for ks:=zgr to zgr+nsc-1 do with dat[ks] do
    begin
    LoadMom(di+name,Mom,OK);
    if OK then begin
               AddMomMat(scprb,k,Mom);
               AddMomMat(cprob*scprb,anzcl+1,Mom);
               end;
    end;
   MomDat^.dat[k].class:=dat[zgr].class;
   MomDat^.dat[k].count:=0;
   MomDat^.dat[k].aprio:=dat[zgr].cprob;
   end;
  MomDat^.anz:=anzcl;
  MomDat^.dat[anzcl+1].class:=' ';
  MomDat^.dat[anzcl+1].count:=0;
  MomDat^.dat[anzcl+1].aprio:=1.0;
  end;

  with KlfDat do
   begin
   for k:=1 to Klanz do
    begin
    for n:=1 to 6 do a[n]:= dat[k].koeff[n];
    keig:=FindCls(dat[k].class);

    for n:=1 to 6 do mxeig[n]:=MomDat^.dat[keig].matrx[n,1];
    mmeig:=MomDat^.dat[keig].matrx;

    cpeig:=MomDat^.dat[keig].aprio; fak:=1/(1-cpeig);
    for n:=1 to 6 do
     begin
     for m:=1 to 6 do mmfrm[n,m]:=fak*MomDat^.dat[MomDat^.anz+1].matrx[n,m]
                                  -cpeig*fak*MomDat^.dat[keig].matrx[n,m];
     mxfrm[n]:=mmfrm[n,1];
     end;

    with EigFrmMod[k] do
     begin
     anzeig:=Round(FktStchp*cpeig);
     meaneig:=SkpVV6(mxeig,a);
     sigmeig:=Sqrt(QuaF6(mmeig,a)-Sqr(meaneig));
     anzfrm:=Round(FktStchp*(1-cpeig));
     meanfrm:=SkpVV6(mxfrm,a);
     sigmfrm:=Sqrt(QuaF6(mmfrm,a)-Sqr(meanfrm));
     end;
    end;
   end;
 end;


procedure PlotNvt(SlctLabel:Char; HistType:Byte);
 Var x,f:Real; k:Word; fak:Real;
 begin
  if SlctLabel<>#32 then
   begin
   k:=1;
   while not (ClsLst[k]=SlctLabel) do Inc(k);
   With EigFrmMod[k] do
    begin
    if HistType in [0,2] then begin
                              fak:=anzeig*Xdel;
                              SetColor(EigHistColor);
                              l_art:=LMuster[EigHistLineStyle];
                              x:=Xanf;
                              f:=fak*WdNvt(x,meaneig,sigmeig);
                              SetV(x,f,v); LMoveToV(v);
                              repeat
                               x:=x+Xdel;
                               f:=fak*WdNvt(x,meaneig,sigmeig);
                               SetV(x,f,v); LLineToV(v);
                              until x>Xend;
                              end;
    if HistType in [1,2] then begin
                              fak:=anzfrm*Xdel;
                              SetColor(FrmHistColor);
                              l_art:=LMuster[FrmHistLineStyle];
                              x:=Xanf;
                              f:=fak*WdNvt(x,meanfrm,sigmfrm);
                              SetV(x,f,v); LMoveToV(v);
                              repeat
                               x:=x+Xdel;
                               f:=fak*WdNvt(x,meanfrm,sigmfrm);
                               SetV(x,f,v); LLineToV(v);
                              until x>Xend;
                              end;
    end;
   end;
 end;

procedure PlotGlbw(SlctLabel:Char);
 Var x,f:Real; k:Word;
 begin
  if SlctLabel<>#32 then
   begin
   k:=1;
   while not (ClsLst[k]=SlctLabel) do Inc(k);
   With EigFrmMod[k] do
    begin
    SetColor(GlaubwColor);
    l_art:=LMuster[GlaubwLineStyle];
    x:=Xanf;
    f:=Glaubwfaktor*Glaubw(x,KlAnz,meaneig,sigmeig,meanfrm,sigmfrm);
    SetV(x,f,v); LMoveToV(v);
    repeat
     x:=x+Xdel;
     f:=Glaubwfaktor*Glaubw(x,KlAnz,meaneig,sigmeig,meanfrm,sigmfrm);
     SetV(x,f,v); LLineToV(v);
    until x>Xend;
    end;
   end;
 end;

procedure KmplKlf(Var KlfDat:KlfDat_T);
 Var k,j:Word;
 begin
 with KlfDat do
  if typ='QMK' then
    begin
    typ:='QMX';
    for k:=1 to anz do with dat[k] do
     begin
     j:=1;
     while not (ClsLst[j]=class) do Inc(j);
     with EigFrmMod[j] do
      begin
      koeff[ 7]:=meaneig;
      koeff[ 8]:=sigmeig;
      koeff[ 9]:=meanfrm;
      koeff[10]:=sigmfrm;
      end;
     end;
    end;
 end;


begin
 New(Hist);
end.