unit JS_QMY;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_koor,js_stm,js_mtr,js_gra,js_mat,js_qmx,js_mdlh,js_glbw;

Type
 GlbwHist_P = ^GlbwHist_T;
 GlbwHist_T = Array[0..AnzIntv+1,1..AnzElemMod] of Real;

Var
 GlbwHist:       GlbwHist_P;
 GlbwHistFertig: Boolean;
 OutlQuantil:    Real;



procedure PfadeInitQMY(PfadeMaske: MskPar_T);
procedure ColorInitQMY(FarbeMaske:MskPar_T);

procedure GlbwHistFromHist;
procedure PlotHistGlbw(k:Word);

procedure OutlGrenzen(k,p:Word; limit:Real; Var un,ob:Real);
procedure MakeGlbw;
procedure SaveGlbw(CnfSvDatei:PathStr; Var OK:Boolean);
procedure PlotGlbw(k:Word);
procedure PlotOutl(k:Word);





Implementation

procedure PfadeInitQMY(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=   PfadeMaske.erg[ 1];
 KoorRdDflt:= PfadeMaske.erg[ 2];
 FarbePfad:=  PfadeMaske.erg[ 3];
 FarbeRdDflt:=PfadeMaske.erg[ 4];
 DVektPfad:=  PfadeMaske.erg[ 5];
 HistPfad:=   PfadeMaske.erg[ 6];
 KlfPfad:=    PfadeMaske.erg[ 7];
 StchpPfad:=  PfadeMaske.erg[ 8];
 CnfPfad:=    PfadeMaske.erg[ 9];
 EditorPfad:= PfadeMaske.erg[10];

 KoorRdDatei:= KoorRdDflt;
 FarbeRdDatei:=FarbeRdDflt;
 end;

procedure ColorInitQMY(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 EigHistColor:=      ColorFromStr(FarbeMaske.erg[4]);
 EigHistLineStyle:=  ValI(Trim(FarbeMaske.erg[5]));
 FrmHistColor:=      ColorFromStr(FarbeMaske.erg[6]);
 FrmHistLineStyle:=  ValI(Trim(FarbeMaske.erg[7]));
 GlaubwColor:=       ColorFromStr(FarbeMaske.erg[8]);
 GlaubwLineStyle:=   ValI(Trim(FarbeMaske.erg[9]));
 GlaubwFaktor:=      ValR(Trim(FarbeMaske.erg[10]));
 end;


procedure GlbwHistFromHist;
 Var n,k:Word;
     eig,frm,glbw:Real; 
 begin
 for k:=1 to KlAnz do
  begin
  for n:=0 to AnzIntv+1 do
   begin
   eig:=Hist^[n,k,1]; frm:=Hist^[n,k,2];
   if eig+frm>0 then glbw:=eig/(eig+frm) else glbw:=0;
   GlbwHist^[n,k]:=glbw;
   end;
  end;
 end;


procedure PlotHistGlbw(k:Word);
 Var v:Vector_2; n:Word; x:Real;
 begin
 SetColor(GlaubwColor);
 l_art:=LMuster[GlaubwLineStyle];
 x:=Xanf+0.5*XDel;
 SetV(x,GlaubwFaktor*GlbwHist^[1,k],v); LMoveToV(v);
 x:=x+XDel;
 for n:=2 to AnzIntv do
  begin
  SetV(x,GlaubwFaktor*GlbwHist^[n,k],v); LLineToV(v);
  x:=x+XDel;
  end;
 end;


procedure OutlGrenzen(k,p:Word; limit:Real; Var un,ob:Real);
 Var n:Integer; sum:Integer;
   unn:real;
 begin
 n:=0; sum:=Hist^[n,k,p];
 While sum<limit do begin
                    Inc(n);
                    sum:=sum+Hist^[n,k,p];
                    end;
 un:=XAnf+(n-1)*Xdel;
 n:=AnzIntv+1; sum:=Hist^[n,k,p];
 While sum<limit do begin
                    Dec(n);
                    sum:=sum+Hist^[n,k,p];
                    end;
 ob:=XAnf+n*Xdel;
 end;



procedure MakeGlbw;
 Var k,n:Word;
 begin
 OptStepGrad:=OptStepGradInit;
 SimFakGrad :=SimFakGradInit;
 with Glbwdat do
  begin
  typ:='GLK'; anz:=KlAnz;
  for k:=1 to anz do
   begin
   with dat[k] do
    begin
    class:=ClsLst[k];
    ParGlbwMod:=ParGlbwModInit;
    for n:=1 to AnzIntv do begin
                           HistEig[n] :=Hist^[n,k,1];
                           HistFrm[n] :=Hist^[n,k,2];
                           HistGlbw[n]:=GlbwHist^[n,k];
                           end;
    SumEig:=SumHist(HistEig);
    SumFrm:=SumHist(HistFrm);
    OptimGlbwModGradAbstieg;
    param:=ParGlbwMod;
    OutlGrenzen(k,1,sumeig*OutlQuantil,outleig[1],outleig[2]); 
    OutlGrenzen(k,2,sumfrm*OutlQuantil,outlfrm[1],outlfrm[2]);
    outloth[1]:=0;
    outloth[2]:=0;
    end;
   end;
  end;
 end;



procedure PlotGlbw(k:Word);
 Var v:Vector_2; n:Word; x:Real;
 begin
 SetColor(GlaubwColor);
 l_art:=LMuster[GlaubwLineStyle];
 with GlbwDat do
  begin
  with dat[k] do
   begin
   ParGlbwMod:=param;
   x:=Xanf+0.5*XDel;
   SetV(x,GlaubwFaktor*GlbwMod(x),v); LMoveToV(v);
   x:=x+XDel;
   for n:=2 to AnzIntv do
    begin
    SetV(x,GlaubwFaktor*GlbwMod(x),v); LLineToV(v);
    x:=x+XDel;
    end;
   end;
  end;
 end;


procedure PlotOutl(k:Word);
 Var   v:Vector_2; n:Word; 
 Const yeig=-0.12; yfrm=-0.13;
 begin
 l_art:=LMuster[0];
 with GlbwDat do
  begin
  with dat[k] do
   begin
   SetColor(EigHistColor);
   SetV(outleig[1],GlaubwFaktor*yeig,v); LMoveToV(v);
   SetV(outleig[2],GlaubwFaktor*yeig,v); LLineToV(v);
   SetColor(FrmHistColor);
   SetV(outlfrm[1],GlaubwFaktor*yfrm,v); LMoveToV(v);
   SetV(outlfrm[2],GlaubwFaktor*yfrm,v); LLineToV(v);
   end;
  end;
 end;
  


procedure SaveGlbw(CnfSvDatei:PathStr; Var OK:Boolean);
 Var k,i:Word; f:text;
 begin
 Assign(f,CnfSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then with GlbwDat do
  begin
  writeln(f,typ);
  for k:=1 to anz do
   begin
   write(f,dat[k].class:3);
   if typ='GLP' then
    write(f,dat[k].cmpcl:3);
   for i:=1 to 6 do write(f,dat[k].param[i]:12:6);
   for i:=1 to 2 do write(f,dat[k].outlfrm[i]:12:6);
   for i:=1 to 2 do write(f,dat[k].outloth[i]:12:6);
   for i:=1 to 2 do write(f,dat[k].outleig[i]:12:6);
   writeln(f);
   end;
  Close(f);
  end;
 end;



begin
 New(GlbwHist);
end.