unit pc_mouse;

interface

uses dos,crt;

type maus = record
             x,y:integer;
             data:array[0..31] of byte;
            end;

const SegPointer : word=$FFFF;
var   MouseHandler : Pointer;

procedure MouseReset;
procedure ShowMouseCursor;
procedure HideMouseCursor;

procedure GetMousePosition(var x,y:integer);
procedure SetMousePosition(x,y:integer);

function LeftButton:boolean;
function RightButton:boolean;

procedure SetMouseWindow(l,o,r,u:integer);

procedure SetGraphicCursor(crs:maus);
procedure SetTextCursor(slct,a,b:integer);

procedure SetMickey(h,v:integer);
procedure SetDoubleSpeed(v:integer);

procedure SetMouseProcedure(m:word;p:pointer);

implementation

procedure MouseReset;
var r:registers;
begin
 r.ax:=0;
 intr($33,r);
end;

procedure ShowMouseCursor;
var r:registers;
begin
 r.ax:=1;
 intr($33,r);
end;

procedure HideMouseCursor;
var r:registers;
begin
 r.ax:=2;
 intr($33,r);
end;

procedure GetMousePosition(var x,y:integer);
var r:registers;
begin
 r.ax:=3;
 intr($33,r);
 x:=r.cx;
 y:=r.dx;
end;

function LeftButton:boolean;
var r:registers;
    xm,ym:integer;
begin
 LeftButton:=false;
 r.ax:=6;
 intr($33,r);
 if (r.ax and 1)=1 then begin
                         GetMousePosition(xm,ym);
                         SetMousePosition(xm,ym);
                         LeftButton:=True
                        end
                   else LeftButton:=False;
end;

function RightButton:boolean;
var r:registers;
    xm,ym:integer;
begin
 r.ax:=6;
 intr($33,r);
 if (r.ax and 2)=2 then begin
                         GetMousePosition(xm,ym);
                         SetMousePosition(xm,ym);
                         RightButton:=True
                        end
                    else RightButton:=False;
end;

procedure SetMousePosition(x,y:integer);
var r:registers;
begin
 r.ax:=4;
 r.cx:=x;
 r.dx:=y;
 intr($33,r);
end;

procedure SetMouseWindow(l,o,r,u:integer);
var re:registers;
begin
 re.ax:=7;
 re.cx:=l;
 re.dx:=r;
 intr($33,re);
 re.ax:=8;
 re.cx:=o;
 re.dx:=u;
 intr($33,re);
end;

procedure SetGraphicCursor(crs:maus);
var r:registers;
begin
 r.ax:=9;
 r.bx:=crs.x;
 r.cx:=crs.y;
 r.dx:=ofs(crs.data);
 intr($33,r);
end;

procedure SetTextCursor(slct,a,b:integer);
var r:registers;
begin
 r.ax:=10;
 r.bx:=slct;
 r.cx:=a;
 r.dx:=b;
 intr($33,r);
end;

procedure SetMickey(h,v:integer);
var r:registers;
begin
 r.ax:=15;
 r.cx:=h;
 r.dx:=v;
 intr($33,r);
end;

procedure SetDoubleSpeed(v:integer);
var r:registers;
begin
 r.ax:=19;
 r.bx:=v;
 intr($33,r);
end;

procedure MouseCallExit;
begin
 Inline($5D/$58/$58/$89/$EC/$5D/$07/$1F/
        $5F/$5E/$5A/$59/$5B/$58/$CB);
end;

procedure UserHandlerCall(mask,button,x,y:word);
begin
 Inline($FF/$1E/MouseHandler);
end;

procedure MouseInterrupt(flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp:word);
interrupt;
begin
 UserHandlerCall(ax,bx,cx,dx);
 MouseCallExit;
end;

procedure SetMouseProcedure(m:word;p:pointer);
var r:registers;
begin
 r.ax:=12;
 r.bx:=m;
 r.dx:=ofs(MouseInterrupt);
 SegPointer:=Seg(MouseInterrupt);
 MouseHandler:=p;
 intr($33,r);
end;

begin
end.